// implementation of declaration

// because of calls from threads at same time
// as much as we can, we included few headers

#include <sdkddkver.h>
#include <mfplay.h>
#include "lockee.h"
#include "locker.h"
#include "neat.h"
#include "backer.h"

backer::backer()
{
    m_count = 1; // after create, increment is not need
    zeroize(m_header);
}

backer::~backer()
{
}

ULONG STDMETHODCALLTYPE backer::AddRef()
{
    // lock is because of threads
    return InterlockedIncrement(&m_count);
}

ULONG STDMETHODCALLTYPE backer::Release()
{
    // lock is because of threads
    int count = InterlockedDecrement(&m_count);
    if (count == 0) delete this; return count;
}

HRESULT STDMETHODCALLTYPE backer::QueryInterface(REFIID demand, void ** object)
{
    if (object == NULL) return E_INVALIDARG;

    *object = NULL;

    if (demand == IID_IUnknown)
    {
     // check of type, safe than cast
     IUnknown * pointer = this;
     pointer->AddRef(); *object = pointer;
     return S_OK;
    }

    if (demand == IID_IMFPMediaPlayerCallback)
    {
     // check of type, safe than cast
     IMFPMediaPlayerCallback * pointer = this;
     pointer->AddRef(); *object = pointer;
     return S_OK;
    }

    return E_NOINTERFACE;
}

void STDMETHODCALLTYPE backer::OnMediaPlayerEvent(MFP_EVENT_HEADER * header)
{
locker lock(this); // because of threads

    // structures are not need to cast
    // such as MFP_MEDIAITEM_SET_EVENT

    // let us save some things as hints
    // without pointers because of pass

    if (header)
    {
     m_header.eEventType = header->eEventType;
     m_header.eState = header->eState;
     m_header.hrEvent = header->hrEvent;
    }
}

const MFP_EVENT_HEADER backer::status()
{
locker lock(this); // because of threads

    return m_header;
}
