// implementation of declaration

#include <sdkddkver.h>
#include <afxwin.h>
#include "common.h"

// it finds message of error
CString code_to_text(const unsigned long error)
{
CString string;
char text[1024];
HMODULE library;

    // string is empty initially
    // orders of searches may be changed

    // search the system
    // for example ERROR_INVALID_FUNCTION
    if (string.IsEmpty())
    {
     if (FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,NULL,error,0,text,sizeof(text),NULL))
     {
      string = text; string.Trim();
     }
    }

    // search the Media Foundation
    // for example MF_E_PLATFORM_NOT_INITIALIZED
    if (string.IsEmpty())
    {
     library = LoadLibrary("mferror.dll");
     if (library)
     {
      if (FormatMessage(FORMAT_MESSAGE_FROM_HMODULE,library,error,0,text,sizeof(text),NULL))
      {
       string = text; string.Trim();
      }
      FreeLibrary(library); library = NULL;
     }
    }

    // search the DirectShow
    // for example VFW_E_INVALIDMEDIATYPE
    if (string.IsEmpty())
    {
     library = LoadLibrary("quartz.dll");
     if (library)
     {
      if (FormatMessage(FORMAT_MESSAGE_FROM_HMODULE,library,error,0,text,sizeof(text),NULL))
      {
       string = text; string.Trim();
      }
      FreeLibrary(library); library = NULL;
     }
    }

    // last remedy
    if (string.IsEmpty())
    {
     string.Format("Error is %lu.",error);
    }

    return string;
}

// it is together macro, relevant to name, in file of header
void name_to_text(CString & string, const int other, const int value, PCSTR name)
{
    if (other == value)
    {
     if (string == "")
     {
      string = name;
     }
    }
}

// it is load of over of above
void name_to_text(CString & string, const GUID other, const GUID value, PCSTR name)
{
    if (other == value)
    {
     if (string == "")
     {
      string = name;
     }
    }
}

// it tests type of text
// type may be combination of _UPPER, _BLANK, and so forth
bool type_of_text(PCSTR text, const int length, const int type)
{
int amount = 0;

    if (text)
    {
     if (length)
     {
      if (type)
      {
       for (int index = 0; index < length; index++)
       {
        if (_isctype((unsigned char)text[index],type))
        {
         amount++;
        }
       }
      }
     }
    }

    // all of characters must suit to succeed
    if (amount) if (amount == length) return true;

    return false;
}

// it finds type of content
CString get_mime(PCSTR name)
{
CString string;
CFile file;
BYTE data[256]; // more is not used
unsigned long amount;
PWSTR type;
HRESULT result;

    if (name)
    {
     if (file.Open(name,file.modeRead|file.shareDenyWrite))
     {
      amount = file.Read(data,sizeof(data));
      if (amount)
      {
       result = FindMimeFromData(NULL,NULL,data,amount,NULL,FMFD_DEFAULT,&type,0);
       if (SUCCEEDED(result))
       {
        string = type; string.Trim();
        CoTaskMemFree(type); type = NULL;
       }
      }
     }
    }

    // class closes its file at end of scope

    return string;
}

// it gets name of module
// parameter may be null for current
CString get_name(const HMODULE module)
{
char text[MAX_PATH];

    const unsigned int length = GetModuleFileName(module,text,sizeof(text));

    // for compatibility, let us check specially

    if (length > 0)
    {
     if (length < sizeof(text))
     {
      return text;
     }
    }

    return "";
}

// it gets part of path
CString get_part(PCSTR path, const part_of_path which)
{
CString string;
char text[MAX_PATH];
int index;

    if (path)
    {
     if (strlen(path) < sizeof(text))
     {
      switch (which)
      {
       case head_of_path:
       strcpy_s(text,sizeof(text),path);
       PathRemoveExtension(text);
       string = PathFindFileName(text);
       string.Trim();
       index = string.Find(32);
       if (index >= 0) string.Truncate(index);
       string.Trim();
       break;

       case body_of_path:
       strcpy_s(text,sizeof(text),path);
       PathRemoveExtension(text);
       string = PathFindFileName(text);
       string.Trim();
       break;

       case tail_of_path:
       strcpy_s(text,sizeof(text),path);
       string = PathFindExtension(text);
       string.Delete(0); // it does not problem for empty
       string.Trim();
       break;
      }
     }
    }

    return string;
}

// it sets text of window, with few flash
void set_text(CWnd & window, PCSTR newer)
{
    CString older; window.GetWindowText(older);
    if (older.Compare(newer)) window.SetWindowText(newer);
}

// it opens window to select file
CString open_file(const HWND owner)
{
PCSTR pairs[] =
{

"Any",
"*.*",

"Advanced Systems Format",
"*.asf;*.wma;*.wmv",

"Moving Picture Experts Group",
"*.mp4;*.mpa;*.mpg",

"Musical Instrument Digital Interface",
"*.mid",

"Resource Interchange File Format",
"*.avi;*.wav"

};

CString filter;
OPENFILENAME data = {};
char text[MAX_PATH] = {};

    // make filter
    for (int index = 0; index < RTL_NUMBER_OF(pairs); index += 2)
    {
     filter.Append(pairs[index]);
     filter.Append(" ");
     filter.Append("(");
     filter.Append(pairs[index+1]);
     filter.Append(")");
     filter.Append("+");
     filter.Append(pairs[index+1]);
     filter.Append("+");
    }

    // finish filter (double-null at most-end as rule)
    filter.Append("+");
    filter.Append("+");
    filter.Replace('+',NULL); // length outdated (but we not need)

    // make data
    data.lStructSize = sizeof(data);
    data.Flags = OFN_ENABLESIZING | OFN_EXPLORER | OFN_HIDEREADONLY;
    data.FlagsEx = OFN_EX_NOPLACESBAR;
    data.hwndOwner = owner;
    data.lpstrFilter = filter;
    data.lpstrFile = text;
    data.nMaxFile = sizeof(text);

    // get name from user
    if (GetOpenFileName(&data)) return text; else return "";
}
