// implementation of declaration

#include <sdkddkver.h>
#include <afxwin.h>
#include <afxext.h>
#include <afxcmn.h>
#include "resource.h"
#include "dialoger.h"

BEGIN_MESSAGE_MAP(dialoger, CDialogBar)
    ON_WM_DESTROY()
    ON_WM_SIZE()
    ON_WM_HSCROLL()
    ON_WM_CTLCOLOR()
END_MESSAGE_MAP()

dialoger::dialoger()
{
}

dialoger::~dialoger()
{
}

void dialoger::initialize()
{
    m_seek.Attach(GetDlgItem(IDC_DIALOG_SEEK)->m_hWnd);
    m_seek_buddy_1.Attach(GetDlgItem(IDC_DIALOG_SEEK_BUDDY_1)->m_hWnd);
    m_seek_buddy_2.Attach(GetDlgItem(IDC_DIALOG_SEEK_BUDDY_2)->m_hWnd);
    m_play.Attach(GetDlgItem(IDC_DIALOG_PLAY)->m_hWnd);
    m_pause.Attach(GetDlgItem(IDC_DIALOG_PAUSE)->m_hWnd);
    m_stop.Attach(GetDlgItem(IDC_DIALOG_STOP)->m_hWnd);
    m_name.Attach(GetDlgItem(IDC_DIALOG_NAME)->m_hWnd);

    m_seek.SetRange(0,100);
    m_seek.SetTicFreq(10);
    m_seek.SetPageSize(10);
    m_seek.SetLineSize(1);
    m_seek.SetPos(0);
    m_seek.SetBuddy(&m_seek_buddy_1,TRUE);
    m_seek.SetBuddy(&m_seek_buddy_2,FALSE);

    m_name.SetWindowText("");
}

void dialoger::OnDestroy()
{
    CDialogBar::OnDestroy();

    m_seek.Detach();
    m_seek_buddy_1.Detach();
    m_seek_buddy_2.Detach();
    m_play.Detach();
    m_pause.Detach();
    m_stop.Detach();
    m_name.Detach();
}

// it may be called before childs were created
void dialoger::OnSize(unsigned int type, int width, int height)
{
    CDialogBar::OnSize(type,width,height);

    if (m_hWnd)
    {
     if (m_seek.m_hWnd)
     {
      RECT rectangle;
      m_seek.GetWindowRect(&rectangle);
      ScreenToClient(&rectangle);
      rectangle.right = width - rectangle.left; // stretch to right
      if ((rectangle.right - rectangle.left) < 47) rectangle.right = rectangle.left + 47; // hard coded value
      m_seek.MoveWindow(&rectangle); // it must work in any case, else it remains outdated
     }
    }
}

void dialoger::OnHScroll(UINT code, UINT position, CScrollBar * bar)
{
    if (code != SB_ENDSCROLL) // defer is nope
    {
     if (bar)
     {
      if (bar->m_hWnd)
      {
       if (bar->m_hWnd == m_seek.m_hWnd)
       {
        // it forwards till relevant window
        SendMessage(WM_COMMAND,IDC_DIALOG_SEEK);
       }
      }
     }
    }

    CDialogBar::OnHScroll(code,position,bar);
}

HBRUSH dialoger::OnCtlColor(CDC * context, CWnd * window, UINT type)
{
    // brush for back of window
    // first this to not lose our settings in context
    HBRUSH brush = CDialogBar::OnCtlColor(context,window,type);

    if (window)
    {
     if (window->m_hWnd)
     {
      if (window->m_hWnd == m_name.m_hWnd)
      {
       if (context)
       {
        // let fore of text be green
        // let back of text be transparent
        context->SetTextColor(RGB(0,128,0)); // may not suit to theme
        context->SetBkMode(TRANSPARENT);
       }
      }
     }
    }

    return brush;
}
