// implementation of declaration

#include <sdkddkver.h>
#include <afxwin.h>
#include <afxext.h>
#include <afxcmn.h>
#include <mfplay.h>
#include "resource.h"
#include "editor.h"
#include "lockee.h"
#include "backer.h"
#include "common.h"
#include "dialoger.h"
#include "keeper.h"
#include "media.h"
#include "neat.h"
#include "stater.h"
#include "tracer.h"
#include "viewer.h"
#include "framer.h"

BEGIN_MESSAGE_MAP(framer, CFrameWnd)

    // time of happen
    ON_WM_CREATE()
    ON_WM_CLOSE()
    ON_WM_ACTIVATEAPP()
    ON_WM_KEYDOWN()
    ON_WM_TIMER()

    // time of show
    ON_UPDATE_COMMAND_UI(ID_MENU_FILE_OPEN, framer::on_update_file_open)
    ON_UPDATE_COMMAND_UI(ID_MENU_FILE_CLOSE, framer::on_update_file_close)
    ON_UPDATE_COMMAND_UI(ID_MENU_FILE_ATTRIBUTES, framer::on_update_file_attributes)
    ON_UPDATE_COMMAND_UI(ID_MENU_FILE_COMPONENTS, framer::on_update_file_components)
    ON_UPDATE_COMMAND_UI(ID_MENU_FILE_PROPERTIES, framer::on_update_file_properties)
    ON_UPDATE_COMMAND_UI(ID_MENU_FILE_STATISTICS, framer::on_update_file_statistics)
    ON_UPDATE_COMMAND_UI(ID_MENU_MEDIA_INCREASE_SOUND, framer::on_update_media_increase_sound)
    ON_UPDATE_COMMAND_UI(ID_MENU_MEDIA_DECREASE_SOUND, framer::on_update_media_decrease_sound)
    ON_UPDATE_COMMAND_UI(ID_MENU_MEDIA_INCREASE_SCALE, framer::on_update_media_increase_scale)
    ON_UPDATE_COMMAND_UI(ID_MENU_MEDIA_DECREASE_SCALE, framer::on_update_media_decrease_scale)
    ON_UPDATE_COMMAND_UI(ID_MENU_MEDIA_INCREASE_SPEED, framer::on_update_media_increase_speed)
    ON_UPDATE_COMMAND_UI(ID_MENU_MEDIA_DECREASE_SPEED, framer::on_update_media_decrease_speed)
    ON_UPDATE_COMMAND_UI(ID_MENU_PREFERENCE_CAPABILITIES, framer::on_update_preference_capabilities)
    ON_UPDATE_COMMAND_UI(ID_MENU_PREFERENCE_AUDIO, framer::on_update_preference_audio)
    ON_UPDATE_COMMAND_UI(ID_MENU_PREFERENCE_VIDEO, framer::on_update_preference_video)
    ON_UPDATE_COMMAND_UI(ID_MENU_VIEW_DIALOG, framer::on_update_view_dialog)
    ON_UPDATE_COMMAND_UI(ID_MENU_VIEW_STATUS, framer::on_update_view_status)
    ON_UPDATE_COMMAND_UI(ID_MENU_VIEW_FILL, framer::on_update_view_fill)
    ON_UPDATE_COMMAND_UI(ID_MENU_VIEW_FULL, framer::on_update_view_full)

    // time of idle
    ON_UPDATE_COMMAND_UI(IDC_DIALOG_SEEK, framer::on_update_dialog_seek)
    ON_UPDATE_COMMAND_UI(IDC_DIALOG_PLAY, framer::on_update_dialog_play)
    ON_UPDATE_COMMAND_UI(IDC_DIALOG_PAUSE, framer::on_update_dialog_pause)
    ON_UPDATE_COMMAND_UI(IDC_DIALOG_STOP, framer::on_update_dialog_stop)
    ON_UPDATE_COMMAND_UI(IDC_DIALOG_NAME, framer::on_update_dialog_name)

    // time of idle
    ON_UPDATE_COMMAND_UI(ID_STATUS_POSITION, framer::on_update_status_position)
    ON_UPDATE_COMMAND_UI(ID_STATUS_SOUND, framer::on_update_status_sound)
    ON_UPDATE_COMMAND_UI(ID_STATUS_SCALE, framer::on_update_status_scale)
    ON_UPDATE_COMMAND_UI(ID_STATUS_SPEED, framer::on_update_status_speed)

    // time of press
    ON_COMMAND(ID_MENU_FILE_OPEN, framer::on_file_open)
    ON_COMMAND(ID_MENU_FILE_CLOSE, framer::on_file_close)
    ON_COMMAND(ID_MENU_FILE_ATTRIBUTES, framer::on_file_attributes)
    ON_COMMAND(ID_MENU_FILE_COMPONENTS, framer::on_file_components)
    ON_COMMAND(ID_MENU_FILE_PROPERTIES, framer::on_file_properties)
    ON_COMMAND(ID_MENU_FILE_STATISTICS, framer::on_file_statistics)
    ON_COMMAND(ID_MENU_MEDIA_INCREASE_SOUND, framer::on_media_increase_sound)
    ON_COMMAND(ID_MENU_MEDIA_DECREASE_SOUND, framer::on_media_decrease_sound)
    ON_COMMAND(ID_MENU_MEDIA_INCREASE_SCALE, framer::on_media_increase_scale)
    ON_COMMAND(ID_MENU_MEDIA_DECREASE_SCALE, framer::on_media_decrease_scale)
    ON_COMMAND(ID_MENU_MEDIA_INCREASE_SPEED, framer::on_media_increase_speed)
    ON_COMMAND(ID_MENU_MEDIA_DECREASE_SPEED, framer::on_media_decrease_speed)
    ON_COMMAND(ID_MENU_PREFERENCE_CAPABILITIES, framer::on_preference_capabilities)
    ON_COMMAND(ID_MENU_PREFERENCE_AUDIO, framer::on_preference_audio)
    ON_COMMAND(ID_MENU_PREFERENCE_VIDEO, framer::on_preference_video)
    ON_COMMAND(ID_MENU_VIEW_DIALOG, framer::on_view_dialog)
    ON_COMMAND(ID_MENU_VIEW_STATUS, framer::on_view_status)
    ON_COMMAND(ID_MENU_VIEW_FILL, framer::on_view_fill)
    ON_COMMAND(ID_MENU_VIEW_FULL, framer::on_view_full)

    // time of press
    ON_COMMAND(IDC_DIALOG_SEEK, framer::on_dialog_seek)
    ON_COMMAND(IDC_DIALOG_PLAY, framer::on_dialog_play)
    ON_COMMAND(IDC_DIALOG_PAUSE, framer::on_dialog_pause)
    ON_COMMAND(IDC_DIALOG_STOP, framer::on_dialog_stop)

END_MESSAGE_MAP()

framer::framer()
{
    m_timer = 0;
    m_preference_audio = true;
    m_preference_video = true;
    m_fill_screen = false;
    m_full_screen = false;
    m_save_place.top = 0;
    m_save_place.left = 0;
    m_save_place.right = 0;
    m_save_place.bottom = 0;
    m_save_style = 0;
    m_save_menu = 0;
    m_save_dialog = FALSE;
    m_save_status = FALSE;
    m_save_source.top = 0;
    m_save_source.left = 0;
    m_save_source.right = 0;
    m_save_source.bottom = 0;
}

framer::~framer()
{
}

BOOL framer::PreCreateWindow(CREATESTRUCT & data)
{
    if (CFrameWnd::PreCreateWindow(data) == FALSE) return FALSE;

    data.style = WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX;
    data.dwExStyle = WS_EX_WINDOWEDGE; // it is affected by other styles
    data.lpszClass = AfxRegisterWndClass(0,NULL,NULL,LoadIcon(NULL,IDI_APPLICATION)); // it is to fix the icon in bar of task, and to reduce the flicker while sizing of window

    return TRUE;
}

int framer::OnCreate(CREATESTRUCT * data)
{
    if (CFrameWnd::OnCreate(data) == -1) return -1;

    if (m_view.Create(NULL,NULL,AFX_WS_DEFAULT_VIEW,CRect(0,0,0,0),this,AFX_IDW_PANE_FIRST,NULL) == FALSE) return -1;
    if (m_status.Create(this,WS_CHILD|WS_VISIBLE|CBRS_BOTTOM,AFX_IDW_STATUS_BAR) == FALSE) return -1;
    if (m_dialog.Create(this,IDD_DIALOG,CBRS_ALIGN_BOTTOM,AFX_IDW_DIALOGBAR) == FALSE) return -1;

    // turn from font-of-edit into font-of-run
    m_font.CreatePointFont(0,"obelus"); SetFont(&m_font);
    SendMessageToDescendants(WM_SETFONT,(WPARAM)m_font.m_hObject);

    // view does not need
    m_dialog.initialize();
    m_status.initialize();

    // check fraction for aspect ratio
    // 32 solves the 4:3 and the 16:9
    // also it solves the even number
    // (height and width become even)
    if (m_dialog.m_sizeDefault.cx % 32) return -1;

    // need for following
    CRect rectangle1;
    CRect rectangle2;
    RecalcLayout();

    // change size for wide ratio
    GetWindowRect(&rectangle1);
    m_view.GetClientRect(&rectangle2);
    rectangle1.right  -= rectangle2.right;
    rectangle1.bottom -= rectangle2.bottom;
    rectangle1.right  += m_dialog.m_sizeDefault.cx;
    rectangle1.bottom += m_dialog.m_sizeDefault.cx * 9 / 16;
    MoveWindow(&rectangle1);

    // check size for middle ratio
    m_view.GetClientRect(&rectangle1);
    m_dialog.GetWindowRect(&rectangle2);
    rectangle1.bottom += rectangle2.bottom;
    rectangle1.bottom -= rectangle2.top;
    if (rectangle1.Height() != (rectangle1.Width() * 3 / 4)) return -1;

    // check width for maximized window
    GetWindowRect(&rectangle1);
    m_view.GetClientRect(&rectangle2);
    rectangle1.right -= rectangle1.left;
    rectangle1.right -= rectangle2.right;
    rectangle1.right += GetSystemMetrics(SM_CXSCREEN);
    rectangle1.right -= GetSystemMetrics(SM_CXMAXIMIZED);
    if (rectangle1.right) return -1; // is width full ?

    // check border for few flicker
    for (CWnd * window = GetTopWindow(); window; window = window->GetNextWindow())
    {
     window->GetWindowRect(&rectangle1);
     window->GetClientRect(&rectangle2);
     if (rectangle1.Width() != rectangle2.Width()) return -1;
     if (rectangle1.Height() != rectangle2.Height()) return -1;
    }

    m_timer = SetTimer(1,1000,NULL);
    if (m_timer == 0) return -1;

    return 0;
}

void framer::OnClose()
{
    m_view.conclude();
    CWnd::OnClose();
}

void framer::OnActivateApp(BOOL active, DWORD thread)
{
    // routine of timer does already
    // but here is to react immediately

    CFrameWnd::OnActivateApp(active,thread);
    if (active == FALSE) do_screen_exit(true);
}

void framer::OnKeyDown(UINT character, UINT count, UINT flags)
{
    if (character == VK_ESCAPE) do_screen_exit(true);
    CFrameWnd::OnKeyDown(character, count, flags);
}

void framer::OnTimer(UINT_PTR identifier)
{
    if (identifier)
    {
     if (identifier == m_timer)
     {
      do_dialog_seek();
      do_dialog_name();
      do_status_position();
      do_status_sound();
      do_status_scale();
      do_status_speed();
      do_format_check();
      do_repeat_play();
      do_screen_exit(false);
     }
    }

    CFrameWnd::OnTimer(identifier);
}

void framer::do_dialog_seek()
{
PROPVARIANT data1;
PROPVARIANT data2;
PROPVARIANT data3;
HRESULT result;

    if (m_view.m_play)
    {
     if (m_view.m_state == MFP_MEDIAPLAYER_STATE_PAUSED)
     {
      return; // user does seek
     }
    }

    PropVariantInit(&data3);

    if (m_view.m_play)
    {
     PropVariantInit(&data1);
     result = m_view.m_play->GetDuration(MFP_POSITIONTYPE_100NS,&data1);
     if (SUCCEEDED(result))
     {
      PropVariantInit(&data2);
      result = m_view.m_play->GetPosition(MFP_POSITIONTYPE_100NS,&data2);
      if (SUCCEEDED(result))
      {
       if (data1.hVal.QuadPart) // avoid divide by zero
       {
        data3.hVal.QuadPart = m_dialog.m_seek.GetRangeMax();
        data3.hVal.QuadPart *= data2.hVal.QuadPart;
        data3.hVal.QuadPart /= data1.hVal.QuadPart;
       }
       PropVariantClear(&data2);
      }
      PropVariantClear(&data1);
     }
    }

    // advance thumb
    m_dialog.m_seek.SetPos(data3.hVal.LowPart);
}

void framer::do_dialog_name()
{
    m_dialog.m_name_string = "";

    if (m_view.m_play)
    {
     if (m_view.m_item)
     {
      m_dialog.m_name_string = get_part(get_file(m_view.m_item),head_of_path);
      m_dialog.m_name_string.Trim();
      m_dialog.m_name_string.MakeUpper(); // for show good
      m_dialog.m_name_string.Insert(0,32); // for show good
      m_dialog.m_name_string.AppendChar(32); // for show good (with ellipsis and fixed-pitch)
      // after above spaces, trim must not be used
     }
    }

    // update of idle does not work while using grip, menu, and so forth
    set_text(m_dialog.m_name,m_dialog.m_name_string);
}

void framer::do_status_position()
{
PROPVARIANT data;
HRESULT result;

    m_status.m_position = "";

    if (m_view.m_play)
    {
     PropVariantInit(&data);
     result = m_view.m_play->GetPosition(MFP_POSITIONTYPE_100NS,&data);
     if (SUCCEEDED(result))
     {
      m_status.m_position.Format("Position %s",time_to_text(data.hVal.QuadPart,true));
      PropVariantClear(&data);
     }
    }

    // update of idle does not work while using grip, menu, and so forth
    m_status.SetPaneText(m_status.CommandToIndex(ID_STATUS_POSITION),m_status.m_position);
}

void framer::do_status_sound()
{
float sound;
HRESULT result;

    m_status.m_sound = "";

    if (m_view.m_play)
    {
     if (m_view.m_audio_stream)
     {
      if (m_view.m_audio_select)
      {
       result = m_view.m_play->GetVolume(&sound);
       if (SUCCEEDED(result))
       {
        sound = round(sound,1);
        m_status.m_sound.Format("Sound %gX",sound);
       }
      }
     }
    }

    // update of idle does not work while using grip, menu, and so forth
    m_status.SetPaneText(m_status.CommandToIndex(ID_STATUS_SOUND),m_status.m_sound);
}

void framer::do_status_scale()
{
MFVideoNormalizedRect rectangle;
float scale;
HRESULT result;

    m_status.m_scale = "";

    if (m_view.m_play)
    {
     if (m_view.m_video_stream)
     {
      if (m_view.m_video_select)
      {
       result = m_view.m_play->GetVideoSourceRect(&rectangle);
       if (SUCCEEDED(result))
       {
        scale = rectangle.bottom - rectangle.top + rectangle.right - rectangle.left;
        if (scale) // avoid divide by zero
        {
         scale = (1.0F + 1.0F) / scale;
         scale = round(scale,1);
         m_status.m_scale.Format("Scale %gX",scale);
        }
       }
      }
     }
    }

    // update of idle does not work while using grip, menu, and so forth
    m_status.SetPaneText(m_status.CommandToIndex(ID_STATUS_SCALE),m_status.m_scale);
}

void framer::do_status_speed()
{
float speed;
HRESULT result;

    m_status.m_speed = "";

    if (m_view.m_play)
    {
     result = m_view.m_play->GetRate(&speed);
     if (SUCCEEDED(result))
     {
      speed = round(speed,1);
      m_status.m_speed.Format("Speed %gX",speed);
     }
    }

    // update of idle does not work while using grip, menu, and so forth
    m_status.SetPaneText(m_status.CommandToIndex(ID_STATUS_SPEED),m_status.m_speed);
}

void framer::do_format_check()
{
SIZE video;
SIZE ratio;

    if (m_view.m_play)
    {
     if (m_view.m_video_stream)
     {
      if (m_view.m_video_select)
      {
       if ((m_view.m_state == MFP_MEDIAPLAYER_STATE_PLAYING) || (m_view.m_state == MFP_MEDIAPLAYER_STATE_PAUSED))
       {
        if (SUCCEEDED(m_view.m_play->GetNativeVideoSize(&video,&ratio)))
        {
         if (video.cx && video.cy && ratio.cx && ratio.cy)
         {
          if ((video.cx * ratio.cy) != (video.cy * ratio.cx))
          {
           // because of the nature of the program
           // we do not allow the change of format
           // such ratio of aspect at time of show

           on_dialog_stop();

           // as part of routine of timer
           // window of notify can not be
           // user can learn it from stop
          }
         }
        }
       }
      }
     }
    }
}

void framer::do_repeat_play()
{
HRESULT result;
MFP_MEDIAPLAYER_STATE state;

    if (m_view.m_play)
    {
     if (m_view.m_state == MFP_MEDIAPLAYER_STATE_PLAYING)
     {
      result = m_view.m_play->GetState(&state);
      if (SUCCEEDED(result))
      {
       if (state == MFP_MEDIAPLAYER_STATE_STOPPED)
       {
        // because of asynchronous operations, state is old
        result = m_view.m_play->Play(); // may be playing already
        // because of asynchronous operations, result is useless
       }
      }
     }
    }
}

void framer::do_screen_exit(const bool force)
{
    if (m_full_screen == false) return;

    if (force == false)
    {
     // when we lost the screen because of reason
     // state happens half-screen and half-window
     // let us prefer to exit from screen as full

     // a reason is switch of window (alt+tab)
     CWnd * window = GetActiveWindow();

     // a reason is change of resolution
     RECT rectangle;
     GetClientRect(&rectangle);
     ClientToScreen(&rectangle);

     if (window)
     if (window->m_hWnd)
     if (window->m_hWnd == m_hWnd)
     if (rectangle.top == 0)
     if (rectangle.left == 0)
     if (rectangle.right == GetSystemMetrics(SM_CXSCREEN))
     if (rectangle.bottom == GetSystemMetrics(SM_CYSCREEN))
     return;
    }

    // while we are showing elements
    // let us pay attention to flash

    ShowCursor(TRUE);
    MoveWindow(&m_save_place);
    ModifyStyle(0,m_save_style,SWP_FRAMECHANGED);
    SetMenuBarState(m_save_menu);
    ShowControlBar(&m_status,m_save_status,FALSE);
    ShowControlBar(&m_dialog,m_save_dialog,FALSE);
    if (m_view.m_play && m_fill_screen) m_view.m_play->SetVideoSourceRect(&m_save_source);

    // provide to seem at back-or-fore of bar-of-task
    CFrameWnd temp; // overlap is more good than popup
    temp.Create(NULL,NULL); // window is hidden
    // class destroys its window at end of scope

    m_full_screen = false;
}

void framer::on_update_file_open(CCmdUI * data)
{
    if (m_view.m_play)
    {
     data->Enable(FALSE);
    }
    else
    {
     data->Enable(TRUE);
    }
}

void framer::on_update_file_close(CCmdUI * data)
{
    if (m_view.m_play)
    {
     data->Enable(TRUE);
    }
    else
    {
     data->Enable(FALSE);
    }
}

void framer::on_update_file_attributes(CCmdUI * data)
{
    if (m_view.m_play)
    {
     data->Enable(TRUE);
    }
    else
    {
     data->Enable(FALSE);
    }
}

void framer::on_update_file_components(CCmdUI * data)
{
    if (m_view.m_play)
    {
     data->Enable(TRUE);
    }
    else
    {
     data->Enable(FALSE);
    }
}

void framer::on_update_file_properties(CCmdUI * data)
{
    if (m_view.m_play)
    {
     data->Enable(TRUE);
    }
    else
    {
     data->Enable(FALSE);
    }
}

void framer::on_update_file_statistics(CCmdUI * data)
{
    if (m_view.m_play)
    {
     data->Enable(TRUE);
    }
    else
    {
     data->Enable(FALSE);
    }
}

void framer::on_update_media_increase_sound(CCmdUI * data)
{
    if (m_view.m_play && m_view.m_audio_stream && m_view.m_audio_select)
    {
     data->Enable(TRUE);
    }
    else
    {
     data->Enable(FALSE);
    }
}

void framer::on_update_media_decrease_sound(CCmdUI * data)
{
    if (m_view.m_play && m_view.m_audio_stream && m_view.m_audio_select)
    {
     data->Enable(TRUE);
    }
    else
    {
     data->Enable(FALSE);
    }
}

void framer::on_update_media_increase_scale(CCmdUI * data)
{
    if (m_view.m_play && m_view.m_video_stream && m_view.m_video_select)
    {
     data->Enable(TRUE);
    }
    else
    {
     data->Enable(FALSE);
    }
}

void framer::on_update_media_decrease_scale(CCmdUI * data)
{
    if (m_view.m_play && m_view.m_video_stream && m_view.m_video_select)
    {
     data->Enable(TRUE);
    }
    else
    {
     data->Enable(FALSE);
    }
}

void framer::on_update_media_increase_speed(CCmdUI * data)
{
    if (m_view.m_play)
    {
     data->Enable(TRUE);
    }
    else
    {
     data->Enable(FALSE);
    }
}

void framer::on_update_media_decrease_speed(CCmdUI * data)
{
    if (m_view.m_play)
    {
     data->Enable(TRUE);
    }
    else
    {
     data->Enable(FALSE);
    }
}

void framer::on_update_preference_capabilities(CCmdUI * data)
{
    if (m_view.m_play)
    {
     data->Enable(FALSE);
    }
    else
    {
     data->Enable(TRUE);
    }
}

void framer::on_update_preference_audio(CCmdUI * data)
{
    if (m_view.m_play)
    {
     data->Enable(FALSE);
    }
    else
    {
     data->Enable(TRUE);
    }

    if (m_preference_audio)
    {
     data->SetCheck(TRUE);
    }
    else
    {
     data->SetCheck(FALSE);
    }
}

void framer::on_update_preference_video(CCmdUI * data)
{
    if (m_view.m_play)
    {
     data->Enable(FALSE);
    }
    else
    {
     data->Enable(TRUE);
    }

    if (m_preference_video)
    {
     data->SetCheck(TRUE);
    }
    else
    {
     data->SetCheck(FALSE);
    }
}

void framer::on_update_view_dialog(CCmdUI * data)
{
    if (m_dialog.IsVisible())
    {
     data->SetCheck(TRUE);
    }
    else
    {
     data->SetCheck(FALSE);
    }
}

void framer::on_update_view_status(CCmdUI * data)
{
    if (m_status.IsVisible())
    {
     data->SetCheck(TRUE);
    }
    else
    {
     data->SetCheck(FALSE);
    }
}

void framer::on_update_view_fill(CCmdUI * data)
{
BOOL flag = FALSE;

    if (m_view.m_play)
    {
     if (m_view.m_video_stream)
     {
      if (m_view.m_video_select)
      {
       if (m_view.m_state == MFP_MEDIAPLAYER_STATE_PLAYING)
       {
        if (m_full_screen == false)
        {
         flag = TRUE;
        }
       }
      }
     }
    }

    data->Enable(flag);

    if (m_fill_screen)
    {
     data->SetCheck(TRUE);
    }
    else
    {
     data->SetCheck(FALSE);
    }
}

void framer::on_update_view_full(CCmdUI * data)
{
BOOL flag = FALSE;

    if (m_view.m_play)
    {
     if (m_view.m_video_stream)
     {
      if (m_view.m_video_select)
      {
       if (m_view.m_state == MFP_MEDIAPLAYER_STATE_PLAYING)
       {
        if (m_full_screen == false)
        {
         flag = TRUE;
        }
       }
      }
     }
    }

    data->Enable(flag);
}

void framer::on_update_dialog_seek(CCmdUI * data)
{
    if ((m_view.m_play != NULL) && (m_view.m_state == MFP_MEDIAPLAYER_STATE_PAUSED))
    {
     data->Enable(TRUE);
    }
    else
    {
     data->Enable(FALSE);
    }

    if (m_view.m_play == NULL)
    {
     if (m_dialog.m_seek.GetPos())
     {
      m_dialog.m_seek.SetPos(0); // reset thumb because file is nope
     }
    }
}

void framer::on_update_dialog_play(CCmdUI * data)
{
    if ((m_view.m_play != NULL) && ((m_view.m_state == MFP_MEDIAPLAYER_STATE_PAUSED) || (m_view.m_state == MFP_MEDIAPLAYER_STATE_STOPPED)))
    {
     data->Enable(TRUE);
    }
    else
    {
     data->Enable(FALSE);
    }

    if ((m_view.m_play != NULL) && (m_view.m_state == MFP_MEDIAPLAYER_STATE_PLAYING))
    {
     data->SetCheck(TRUE);
    }
    else
    {
     data->SetCheck(FALSE);
    }
}

void framer::on_update_dialog_pause(CCmdUI * data)
{
    if ((m_view.m_play != NULL) && (m_view.m_state == MFP_MEDIAPLAYER_STATE_PLAYING))
    {
     data->Enable(TRUE);
    }
    else
    {
     data->Enable(FALSE);
    }

    if ((m_view.m_play != NULL) && (m_view.m_state == MFP_MEDIAPLAYER_STATE_PAUSED))
    {
     data->SetCheck(TRUE);
    }
    else
    {
     data->SetCheck(FALSE);
    }
}

void framer::on_update_dialog_stop(CCmdUI * data)
{
    if ((m_view.m_play != NULL) && ((m_view.m_state == MFP_MEDIAPLAYER_STATE_PLAYING) || (m_view.m_state == MFP_MEDIAPLAYER_STATE_PAUSED)))
    {
     data->Enable(TRUE);
    }
    else
    {
     data->Enable(FALSE);
    }

    if ((m_view.m_play != NULL) && (m_view.m_state == MFP_MEDIAPLAYER_STATE_STOPPED))
    {
     data->SetCheck(TRUE);
    }
    else
    {
     data->SetCheck(FALSE);
    }
}

void framer::on_update_dialog_name(CCmdUI * data)
{
    if (m_view.m_play == NULL) m_dialog.m_name_string = "";

    data->SetText(m_dialog.m_name_string);
}

void framer::on_update_status_position(CCmdUI * data)
{
    if (m_view.m_play == NULL) m_status.m_position = "";

    data->SetText(m_status.m_position);
}

void framer::on_update_status_sound(CCmdUI * data)
{
    if (m_view.m_play == NULL) m_status.m_sound = "";

    data->SetText(m_status.m_sound);
}

void framer::on_update_status_scale(CCmdUI * data)
{
    if (m_view.m_play == NULL) m_status.m_scale = "";

    data->SetText(m_status.m_scale);
}

void framer::on_update_status_speed(CCmdUI * data)
{
    if (m_view.m_play == NULL) m_status.m_speed = "";

    data->SetText(m_status.m_speed);
}

void framer::on_file_open()
{
CString name;
LRESULT result;

    if (m_view.m_play == NULL)
    {
     name = open_file(m_hWnd);
     if (name.GetLength())
     {
      result = m_view.commence(name,m_preference_audio,m_preference_video);
      if (result)
      {
       MessageBox(code_to_text(result),"Open");
      }
     }
    }
}

void framer::on_file_close()
{
    m_view.conclude();
    m_view.RedrawWindow();
}

void framer::on_file_attributes()
{
    if (m_view.m_play)
    {
     if (m_view.m_item)
     {
      keeper window;
      window.m_caption = "Attributes";
      window.m_content = get_attributes(m_view.m_item);
      window.DoModal();
     }
    }
}

void framer::on_file_components()
{
    if (m_view.m_play)
    {
     if (m_view.m_item)
     {
      keeper window;
      window.m_caption = "Components";
      window.m_content = get_components(m_view.m_item);
      window.DoModal();
     }
    }
}

void framer::on_file_properties()
{
    if (m_view.m_play)
    {
     if (m_view.m_item)
     {
      keeper window;
      window.m_caption = "Properties";
      window.m_content = get_properties(m_view.m_item);
      window.DoModal();
     }
    }
}

void framer::on_file_statistics()
{
    if (m_view.m_play)
    {
     if (m_view.m_item)
     {
      tracer window;
      window.DoModal();
     }
    }
}

void framer::on_media_increase_sound()
{
float sound;

    if (m_view.m_play)
    {
     if (m_view.m_audio_stream)
     {
      if (m_view.m_audio_select)
      {
       if (SUCCEEDED(m_view.m_play->GetVolume(&sound)))
       {
        sound += 0.2F;
        sound = round(sound,1);
        if (sound < 0.0F) sound = 0.0F;
        if (sound > 1.0F) sound = 1.0F;
        m_view.m_play->SetVolume(sound);
       }
      }
     }
    }
}

void framer::on_media_decrease_sound()
{
float sound;

    if (m_view.m_play)
    {
     if (m_view.m_audio_stream)
     {
      if (m_view.m_audio_select)
      {
       if (SUCCEEDED(m_view.m_play->GetVolume(&sound)))
       {
        sound -= 0.2F;
        sound = round(sound,1);
        if (sound < 0.0F) sound = 0.0F;
        if (sound > 1.0F) sound = 1.0F;
        m_view.m_play->SetVolume(sound);
       }
      }
     }
    }
}

void framer::on_media_increase_scale()
{
MFVideoNormalizedRect rectangle;
float scale;
HRESULT result;

    if (m_view.m_play)
    {
     if (m_view.m_video_stream)
     {
      if (m_view.m_video_select)
      {
       result = m_view.m_play->GetVideoSourceRect(&rectangle);
       if (SUCCEEDED(result))
       {
        scale = rectangle.bottom - rectangle.top + rectangle.right - rectangle.left;
        if (scale > ((1.0F + 1.0F) / 6.0F)) // limit (divisor must be mid of 2 units)
        {
         scale /= 8.0F; // amount (divisor must be power of 2)

         rectangle.top += scale;
         rectangle.left += scale;
         rectangle.right -= scale;
         rectangle.bottom -= scale;

         normalize_rectangle(rectangle);
         m_view.m_play->SetVideoSourceRect(&rectangle);
        }
       }
      }
     }
    }
}

void framer::on_media_decrease_scale()
{
MFVideoNormalizedRect rectangle;
float scale;
HRESULT result;

    if (m_view.m_play)
    {
     if (m_view.m_video_stream)
     {
      if (m_view.m_video_select)
      {
       result = m_view.m_play->GetVideoSourceRect(&rectangle);
       if (SUCCEEDED(result))
       {
        scale = rectangle.bottom - rectangle.top + rectangle.right - rectangle.left;
        if (scale < (1.0F + 1.0F)) // limit (fixed)
        {
         scale /= 4.0F; // amount (divisor must be power of 2)

         rectangle.top -= scale;
         rectangle.left -= scale;
         rectangle.right += scale;
         rectangle.bottom += scale;

         normalize_rectangle(rectangle);
         m_view.m_play->SetVideoSourceRect(&rectangle);
        }
       }
      }
     }
    }
}

void framer::on_media_increase_speed()
{
float speed;

    if (m_view.m_play)
    {
     if (SUCCEEDED(m_view.m_play->GetRate(&speed)))
     {
      speed += 0.5F;
      speed = round(speed,1);
      if (speed < 0.5F) speed = 0.5F;
      if (speed > 1.5F) speed = 1.5F;
      m_view.m_play->SetRate(speed);
     }
    }
}

void framer::on_media_decrease_speed()
{
float speed;

    if (m_view.m_play)
    {
     if (SUCCEEDED(m_view.m_play->GetRate(&speed)))
     {
      speed -= 0.5F;
      speed = round(speed,1);
      if (speed < 0.5F) speed = 0.5F;
      if (speed > 1.5F) speed = 1.5F;
      m_view.m_play->SetRate(speed);
     }
    }
}

void framer::on_preference_capabilities()
{
    if (m_view.m_play == NULL)
    {
     // media is nope, now following is safe

     CString string;
     string.Append(capabilities_of_audio());
     string.Append("\n\n");
     string.Append(capabilities_of_video());
     string.Trim(); // because of mid of them

     keeper window;
     window.m_caption = "Capabilities";
     window.m_content = string;
     window.DoModal();
    }
}

void framer::on_preference_audio()
{
    if (m_view.m_play == NULL)
    {
     if (m_preference_audio)
     {
      m_preference_audio = false;
     }
     else
     {
      m_preference_audio = true;
     }
    }
}

void framer::on_preference_video()
{
    if (m_view.m_play == NULL)
    {
     if (m_preference_video)
     {
      m_preference_video = false;
     }
     else
     {
      m_preference_video = true;
     }
    }
}

void framer::on_view_dialog()
{
    if (m_dialog.IsVisible())
    {
     ShowControlBar(&m_dialog,FALSE,FALSE);
    }
    else
    {
     ShowControlBar(&m_dialog,TRUE,FALSE);
    }

    SetFocus(); // while bar is hidden, prevent work of it
}

void framer::on_view_status()
{
    if (m_status.IsVisible())
    {
     ShowControlBar(&m_status,FALSE,FALSE);
    }
    else
    {
     ShowControlBar(&m_status,TRUE,FALSE);
    }

    SetFocus(); // while bar is hidden, prevent work of it
}

void framer::on_view_fill()
{
    if (m_view.m_play)
    {
     if (m_view.m_video_stream)
     {
      if (m_view.m_video_select)
      {
       if (m_view.m_state == MFP_MEDIAPLAYER_STATE_PLAYING)
       {
        if (m_full_screen == false)
        {
         if (m_fill_screen)
         {
          m_fill_screen = false;
         }
         else
         {
          m_fill_screen = true;
         }
        }
       }
      }
     }
    }
}

void framer::on_view_full()
{
SIZE video;
SIZE target;
size_as_float size_of_source;
MFVideoNormalizedRect source;
RECT rectangle1;
RECT rectangle2;

    if (m_view.m_play)
    {
     if (m_view.m_video_stream)
     {
      if (m_view.m_video_select)
      {
       if (m_view.m_state == MFP_MEDIAPLAYER_STATE_PLAYING) // drag of user loses cursor in state of pause
       {
        if (m_full_screen == false)
        {
         // state of maximize may not be compliant
         // we may disable the full while maximize
         // we may restore from maximize to normal
         // let solutions remain till complication
         if (0) ShowWindow(SW_RESTORE);

         // save before change
         GetWindowRect(&m_save_place);
         m_save_style = GetStyle();
         m_save_menu = GetMenuBarState();
         m_save_dialog = m_dialog.IsVisible();
         m_save_status = m_status.IsVisible();
         m_view.m_play->GetVideoSourceRect(&m_save_source); // take of place, actual in following

         // while we are hiding elements
         // let us pay attention to flash

         if (m_fill_screen)
         {
          if (SUCCEEDED(m_view.m_play->GetNativeVideoSize(&video,NULL)))
          {
           if (SUCCEEDED(m_view.m_play->GetVideoSourceRect(&m_save_source)))
           {
            // about overflow, underflow, and precision
            // type of float is enough in small numbers

            // let us pay attention to divide by zero

            target.cx = GetSystemMetrics(SM_CXSCREEN);
            target.cy = GetSystemMetrics(SM_CYSCREEN);

            // values can be zero
            size_of_source.cx = m_save_source.right - m_save_source.left;
            size_of_source.cy = m_save_source.bottom - m_save_source.top;

            // as pixel
            size_of_source.cx *= video.cx;
            size_of_source.cy *= video.cy;

            // horizontally or vertically, crop of plane
            if ((size_of_source.cx * target.cy) < (size_of_source.cy * target.cx))
            {
             size_of_source.cy = (size_of_source.cx * target.cy) / target.cx;
            }
            else
            {
             size_of_source.cx = (size_of_source.cy * target.cx) / target.cy;
            }

            // as range (natural state)
            size_of_source.cx /= video.cx;
            size_of_source.cy /= video.cy;

            // into old rectangle, put of new rectangle, with centering
            source.top = (m_save_source.top + m_save_source.bottom - size_of_source.cy) / 2.0F;
            source.left = (m_save_source.left + m_save_source.right - size_of_source.cx) / 2.0F;
            source.right = (m_save_source.right + m_save_source.left + size_of_source.cx) / 2.0F;
            source.bottom = (m_save_source.bottom + m_save_source.top + size_of_source.cy) / 2.0F;

            normalize_rectangle(source);
            m_view.m_play->SetVideoSourceRect(&source);
           }
          }
         }

         ShowControlBar(&m_dialog,FALSE,FALSE);
         ShowControlBar(&m_status,FALSE,FALSE);

         SetFocus(); // while bar is hidden, prevent work of it

         SetMenuBarState(AFX_MBS_HIDDEN);

         // menu of system can work with key-of-alt and key-of-f10, let us remove it and others
         ModifyStyle(WS_CAPTION|WS_SYSMENU|WS_THICKFRAME|WS_MINIMIZEBOX|WS_MAXIMIZEBOX,0,SWP_FRAMECHANGED);

         // size-of-client with size-of-window may be same
         // but following calculation is for compatibility

         GetWindowRect(&rectangle1);
         GetClientRect(&rectangle2);
         ClientToScreen(&rectangle2);

         // position of window
         rectangle1.top -= rectangle2.top;
         rectangle1.left -= rectangle2.left;
         rectangle1.right -= rectangle2.right;
         rectangle1.bottom -= rectangle2.bottom;

         // append of client
         rectangle1.right += GetSystemMetrics(SM_CXSCREEN);
         rectangle1.bottom += GetSystemMetrics(SM_CYSCREEN);

         MoveWindow(&rectangle1);

         ShowCursor(FALSE);

         // provide to seem at back-or-fore of bar-of-task
         CFrameWnd temp; // overlap is more good than popup
         temp.Create(NULL,NULL); // window is hidden
         // class destroys its window at end of scope

         m_full_screen = true;
        }
       }
      }
     }
    }
}

void framer::on_dialog_seek()
{
PROPVARIANT data;
HRESULT result;

    if (m_view.m_play)
    {
     if (m_view.m_state == MFP_MEDIAPLAYER_STATE_PAUSED) // seek of user does lag in state of play
     {
      PropVariantInit(&data);
      result = m_view.m_play->GetDuration(MFP_POSITIONTYPE_100NS,&data);
      if (SUCCEEDED(result))
      {
       if (m_dialog.m_seek.GetRangeMax()) // avoid divide by zero
       {
        ASSERT(data.vt == VT_UI8); data.vt = VT_I8;
        data.hVal.QuadPart *= m_dialog.m_seek.GetPos();
        data.hVal.QuadPart /= m_dialog.m_seek.GetRangeMax();
        m_view.m_play->SetPosition(MFP_POSITIONTYPE_100NS,&data);
       }
       PropVariantClear(&data);
      }
     }
    }
}

void framer::on_dialog_play()
{
    // because of asynchronous operations
    // update does not work in here for user

    if (m_view.m_play)
    {
     if ((m_view.m_state == MFP_MEDIAPLAYER_STATE_PAUSED) || (m_view.m_state == MFP_MEDIAPLAYER_STATE_STOPPED))
     {
      if (SUCCEEDED(m_view.m_play->Play()))
      {
       m_view.m_state = MFP_MEDIAPLAYER_STATE_PLAYING;
      }
     }
    }
}

void framer::on_dialog_pause()
{
    // because of asynchronous operations
    // update does not work in here for user

    if (m_view.m_play)
    {
     if (m_view.m_state == MFP_MEDIAPLAYER_STATE_PLAYING) // pass is nope from stop to pause
     {
      if (SUCCEEDED(m_view.m_play->Pause()))
      {
       // advance the thumb last time
       do_dialog_seek();

       m_view.m_state = MFP_MEDIAPLAYER_STATE_PAUSED;

       // position of media must not be set in here
       // because it may be slow when index is nope
      }
     }
    }
}

void framer::on_dialog_stop()
{
    // because of asynchronous operations
    // update does not work in here for user

    if (m_view.m_play)
    {
     if ((m_view.m_state == MFP_MEDIAPLAYER_STATE_PLAYING) || (m_view.m_state == MFP_MEDIAPLAYER_STATE_PAUSED))
     {
      if (SUCCEEDED(m_view.m_play->Stop()))
      {
       m_view.m_state = MFP_MEDIAPLAYER_STATE_STOPPED;

       // rewind the media for compatibility
       PROPVARIANT data;
       PropVariantInit(&data);
       data.vt = VT_I8;
       m_view.m_play->SetPosition(MFP_POSITIONTYPE_100NS,&data);
       PropVariantClear(&data);
      }
     }
    }
}
