// implementation of declaration

#include <sdkddkver.h>
#include <afxwin.h>
#include "resource.h"
#include "editor.h"
#include "keeper.h"

BEGIN_MESSAGE_MAP(keeper, CDialog)
    ON_WM_SIZE()
END_MESSAGE_MAP()

keeper::keeper() : CDialog(keeper::IDD)
{
}

keeper::~keeper()
{
}

void keeper::DoDataExchange(CDataExchange * data)
{
    CDialog::DoDataExchange(data);

    DDX_Control(data, IDC_KEEPER_EDIT, m_edit);
}

BOOL keeper::OnInitDialog()
{
    CDialog::OnInitDialog();

    // turn from font-of-edit into font-of-run
    m_font.CreatePointFont(0,"obelus"); SetFont(&m_font);
    SendMessageToDescendants(WM_SETFONT,(WPARAM)m_font.m_hObject);

    // trigger
    CRect rectangle;
    GetClientRect(rectangle);
    m_edit.MoveWindow(0,0,0,0);
    m_edit.MoveWindow(rectangle);

    // integrate
    CRect rectangle1;
    CRect rectangle2;
    GetWindowRect(rectangle1);
    m_edit.GetClientRect(rectangle2);
    rectangle.top = 0;
    rectangle.left = 0;
    rectangle.right = rectangle1.Width() - rectangle2.Width() + (16 * 22);
    rectangle.bottom = rectangle1.Height() - rectangle2.Height() + (16 * 18);
    MoveWindow(rectangle);
    CenterWindow(); // because of change

    // check
    m_edit.GetRect(rectangle1);
    m_edit.GetClientRect(rectangle2);
    rectangle1.InflateRect(8,8,8,8);
    ASSERT(rectangle1 == rectangle2);

    // for compatibility
    m_content.Replace("\r\n","\n"); // carriage-return with line-feed are end-of-line
    m_content.Replace("\n","\r\n"); // let line-feed be end-of-line when mate is nope

    SetWindowText(m_caption);
    m_edit.SetWindowText(m_content);

    return TRUE;
}

// it may be called before childs were created
void keeper::OnSize(unsigned int type, int width, int height)
{
    CDialog::OnSize(type,width,height);

    if (m_hWnd)
    {
     if (m_edit.m_hWnd)
     {
      m_edit.MoveWindow(0,0,width,height);
     }
    }
}
