// implementation of declaration

#include <sdkddkver.h>
#include <afxwin.h>
#include <mfapi.h>
#include <mfplay.h>
#include <initguid.h>
#include <d3d9.h>
#include <dxva2api.h>
#include <mmdeviceapi.h>
#include <audioclient.h>
#include "common.h"
#include "hook.h"
#include "neat.h"
#include "qualifier.h"
#include "media.h"

// it calculates ratio of aspect
CString rate_to_text(unsigned long width, unsigned long height)
{
CString string;
unsigned long number;

    // let count be small-of-them to finish quick
    for (number = width < height ? width : height; number; number--)
    {
     // divide by zero is nope
     if (width % number) continue;
     if (height % number) continue;

     // above does divide in self already
     // but below works one time along loop
     // it does not slowness because of this

     width /= number;
     height /= number;
     break;
    }

    string.Format("%lu:%lu",width,height);
    return string;
}

// it makes string of text from time of media
// hour continues to increase after arrived at day
// under this case; day, week, and so forth are nope
// but, they may be added easily, such as factor of 24
CString time_to_text(MFTIME time, const bool shorter)
{
CString string;
long long hour;
long long minute;
long long second;
long long milli;
long long micro;
long long nano;
long long temp;

    // numbers are big than default
    // because of probability of bug
    // let us not use intermediate values
    // for example "A = A + 1" and "A = B * C"
    // (results of calculations are intermediate)

    // negative can not be
    if (time < 0) return "";

    // unit of time is 100 nanoseconds

    temp = 1LL * 10LL * 1000LL * 1000LL * 60LL * 60LL;
    hour = time; hour /= temp;
    time %= temp;

    temp = 1LL * 10LL * 1000LL * 1000LL * 60LL;
    minute = time; minute /= temp;
    time %= temp;

    temp = 1LL * 10LL * 1000LL * 1000LL;
    second = time; second /= temp;
    time %= temp;

    temp = 1LL * 10LL * 1000LL;
    milli = time; milli /= temp;
    time %= temp;

    temp = 1LL * 10LL;
    micro = time; micro /= temp;
    time %= temp;

    temp = 1LL;
    nano = time; nano /= temp;
    time %= temp;

    // check of finish
    ASSERT(time == 0);

    // multiply by unit
    // overflow is nope
    nano *= 100LL;

    if (shorter)
    {
     // it is short to use normal
     string.Format("%02lld:%02lld:%02lld",hour,minute,second);
    }
    else
    {
     // it is long to solve problem
     string.Format("%02lld:%02lld:%02lld:%03lld:%03lld:%03lld",hour,minute,second,milli,micro,nano);
    }

    return string;
}

// it finds name of type
CString type_to_text(const GUID major, const GUID minor)
{
CString string;

    // search name (alphabeticals, numericals, and blanks at end)
    if (type_of_text((PCSTR)&minor.Data1,sizeof(minor.Data1),_UPPER|_BLANK|_DIGIT|_LOWER))
    {
     string.SetString((PCSTR)&minor.Data1,sizeof(minor.Data1));
     string.Trim();
     // order may be reverse, and letters may be lower
     // because of a rule is nope, let it remain as is
     if (string.GetLength()) return string;
    }

    // search audio
    if (major == MFMediaType_Audio)
    {
     string.Empty();
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_UNKNOWN));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_PCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_IEEE_FLOAT));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VSELP));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_IBM_CVSD));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_ALAW));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_MULAW));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_DTS));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_DRM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_WMAVOICE9));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_WMAVOICE10));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_OKI_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_DVI_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_IMA_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_MEDIASPACE_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_SIERRA_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_G723_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_DIGISTD));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_DIGIFIX));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_DIALOGIC_OKI_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_MEDIAVISION_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_CU_CODEC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_YAMAHA_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_SONARC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_DSPGROUP_TRUESPEECH));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_ECHOSC1));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_AUDIOFILE_AF36));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_APTX));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_AUDIOFILE_AF10));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_PROSODY_1612));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_LRC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_DOLBY_AC2));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_GSM610));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_MSNAUDIO));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_ANTEX_ADPCME));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_CONTROL_RES_VQLPC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_DIGIREAL));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_DIGIADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_CONTROL_RES_CR10));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_NMS_VBXADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_CS_IMAADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_ECHOSC3));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_ROCKWELL_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_ROCKWELL_DIGITALK));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_XEBEC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_G721_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_G728_CELP));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_MSG723));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_MPEG));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_RT24));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_PAC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_MPEGLAYER3));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_LUCENT_G723));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_CIRRUS));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_ESPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VOXWARE));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_CANOPUS_ATRAC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_G726_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_G722_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_DSAT_DISPLAY));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VOXWARE_BYTE_ALIGNED));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VOXWARE_AC8));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VOXWARE_AC10));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VOXWARE_AC16));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VOXWARE_AC20));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VOXWARE_RT24));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VOXWARE_RT29));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VOXWARE_RT29HW));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VOXWARE_VR12));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VOXWARE_VR18));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VOXWARE_TQ40));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_SOFTSOUND));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VOXWARE_TQ60));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_MSRT24));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_G729A));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_MVI_MVI2));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_DF_G726));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_DF_GSM610));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_ISIAUDIO));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_ONLIVE));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_SBC24));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_DOLBY_AC3_SPDIF));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_MEDIASONIC_G723));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_PROSODY_8KBPS));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_ZYXEL_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_PHILIPS_LPCBB));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_PACKED));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_MALDEN_PHONYTALK));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_RAW_AAC1));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_RHETOREX_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_IRAT));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VIVO_G723));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VIVO_SIREN));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_DIGITAL_G723));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_SANYO_LD_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_SIPROLAB_ACEPLNET));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_SIPROLAB_ACELP4800));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_SIPROLAB_ACELP8V3));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_SIPROLAB_G729));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_SIPROLAB_G729A));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_SIPROLAB_KELVIN));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_G726ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_QUALCOMM_PUREVOICE));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_QUALCOMM_HALFRATE));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_TUBGSM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_MSAUDIO1));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_WMAUDIO2));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_WMAUDIO3));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_WMAUDIO_LOSSLESS));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_WMASPDIF));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_UNISYS_NAP_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_UNISYS_NAP_ULAW));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_UNISYS_NAP_ALAW));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_UNISYS_NAP_16K));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_CREATIVE_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_CREATIVE_FASTSPEECH8));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_CREATIVE_FASTSPEECH10));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_UHER_ADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_QUARTERDECK));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_ILINK_VC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_RAW_SPORT));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_ESST_AC3));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_GENERIC_PASSTHRU));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_IPI_HSX));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_IPI_RPELP));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_CS2));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_SONY_SCX));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_FM_TOWNS_SND));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_BTV_DIGITAL));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_QDESIGN_MUSIC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VME_VMPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_TPC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_OLIGSM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_OLIADPCM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_OLICELP));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_OLISBC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_OLIOPR));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_LH_CODEC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_NORRIS));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_SOUNDSPACE_MUSICOMPRESS));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_MPEG_ADTS_AAC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_MPEG_RAW_AAC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_MPEG_LOAS));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_NOKIA_MPEG_ADTS_AAC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_NOKIA_MPEG_RAW_AAC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VODAFONE_MPEG_ADTS_AAC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_VODAFONE_MPEG_RAW_AAC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_MPEG_HEAAC));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_DVM));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_DTS2));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_EXTENSIBLE));
     name_to_text(string,minor.Data1,value_comma_name(WAVE_FORMAT_DEVELOPMENT));
     if (string.GetLength()) return string;
    }

    // search video
    if (major == MFMediaType_Video)
    {
     string.Empty();
     name_to_text(string,minor.Data1,value_comma_name(BI_RGB));
     name_to_text(string,minor.Data1,value_comma_name(BI_RLE8));
     name_to_text(string,minor.Data1,value_comma_name(BI_RLE4));
     name_to_text(string,minor.Data1,value_comma_name(BI_BITFIELDS));
     name_to_text(string,minor.Data1,value_comma_name(BI_JPEG));
     name_to_text(string,minor.Data1,value_comma_name(BI_PNG));
     if (string.GetLength()) return string;
    }

    // search video
    if (major == MFMediaType_Video)
    {
     string.Empty();
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_UNKNOWN));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_R8G8B8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_A8R8G8B8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_X8R8G8B8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_R5G6B5));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_X1R5G5B5));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_A1R5G5B5));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_A4R4G4B4));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_R3G3B2));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_A8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_A8R3G3B2));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_X4R4G4B4));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_A2B10G10R10));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_A8B8G8R8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_X8B8G8R8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_G16R16));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_A2R10G10B10));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_A16B16G16R16));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_A8P8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_P8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_L8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_A8L8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_A4L4));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_V8U8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_L6V5U5));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_X8L8V8U8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_Q8W8V8U8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_V16U16));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_A2W10V10U10));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_UYVY));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_R8G8_B8G8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_YUY2));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_G8R8_G8B8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_DXT1));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_DXT2));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_DXT3));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_DXT4));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_DXT5));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_D16_LOCKABLE));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_D32));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_D15S1));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_D24S8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_D24X8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_D24X4S4));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_D16));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_D32F_LOCKABLE));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_D24FS8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_D32_LOCKABLE));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_S8_LOCKABLE));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_L16));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_VERTEXDATA));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_INDEX16));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_INDEX32));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_Q16W16V16U16));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_MULTI2_ARGB8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_R16F));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_G16R16F));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_A16B16G16R16F));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_R32F));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_G32R32F));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_A32B32G32R32F));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_CxV8U8));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_A1));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_A2B10G10R10_XR_BIAS));
     name_to_text(string,minor.Data1,value_comma_name(D3DFMT_BINARYBUFFER));
     if (string.GetLength()) return string;
    }

    // last remedy
    string.Format("%lu",minor.Data1);
    return string;
}

// it makes string of text from format of audio
CString audio_to_text(const int channel, const int depth, const int rate)
{
CString string;

    string.AppendFormat("%d",channel);
    string.Append("X");
    string.AppendFormat("%d",depth);
    string.Append("@");
    string.AppendFormat("%d",rate);

    return string;
}

// it makes string of text from format of video
CString video_to_text(const int width, const int height, const int depth, const int rate)
{
CString string;

    string.AppendFormat("%d",width);
    string.Append("X");
    string.AppendFormat("%d",height);
    string.Append("X");
    string.AppendFormat("%d",depth);
    string.Append("@");
    string.AppendFormat("%d",rate);

    return string;
}

// it calculates depth of video
unsigned long depth_of_video(const unsigned long type)
{
unsigned long depth; // in bits
unsigned long size; // in bytes
HRESULT result;

    // because of pad, stride, and so forth
    // let us refer to multiple of 8 and 10
    // (bits in byte, and fingers in human)
    // least significant 8 bits of it are 0
    const unsigned long dimension = 1280;

    // perhaps it does look at a constant table
    result = MFGetPlaneSize(type,dimension,dimension,&size);
    if (FAILED(result)) size = 0;

    // round is not need
    depth = (size * 8) / (dimension * dimension);

    // ah ! we were not in need of olden things
    // such as MFInitAMMediaTypeFromMFMediaType

    return depth;
}

// it is about hardware
CString capabilities_of_audio()
{
CString string;
CString string_of_combo;
PROPVARIANT data;
WAVEFORMATEXTENSIBLE extent;
IMMDeviceEnumerator * enumerator;
IMMDevice * device;
IPropertyStore * store;
IAudioClient * client;
const long items[] = { /* frequency modulation radio */ 32000 , /* digital audio disc */ 44100 , /* digital video disc */ 48000 , /* multiple of preceding */ 96000 , /* multiple of preceding */ 192000 };
int index;
HRESULT result;

    ////////////////////////////////////////

    result = CoCreateInstance(_uuidof(MMDeviceEnumerator),NULL,CLSCTX_ALL,IID_PPV_ARGS(&enumerator));
    if (SUCCEEDED(result))
    {
     result = enumerator->GetDefaultAudioEndpoint(eRender,eMultimedia,&device);
     if (SUCCEEDED(result))
     {
      result = device->OpenPropertyStore(STGM_READ,&store);
      if (SUCCEEDED(result))
      {
       PropVariantInit(&data);
       result = store->GetValue(PKEY_AudioEngine_DeviceFormat,&data);
       if (SUCCEEDED(result))
       {
        // IAudioClient::GetMixFormat is of software
        // PKEY_AudioEngine_DeviceFormat is of hardware
        // they cover mode of share, not mode of exclusive

        // when WAVEFORMATEXTENSIBLE::Format.wBitsPerSample is zero
        // then WAVEFORMATEXTENSIBLE::Samples.wSamplesPerBlock is valid
        // else WAVEFORMATEXTENSIBLE::Samples.wValidBitsPerSample is valid

        // for field of extension of foreign, let us provide zero
        // when we will refer, we do check WAVE_FORMAT_EXTENSIBLE

        WAVEFORMATEXTENSIBLE datum; zeroize(datum); datum.Format = *(WAVEFORMATEX *)data.blob.pBlobData;
        if (datum.Format.wFormatTag == WAVE_FORMAT_EXTENSIBLE) datum = *(WAVEFORMATEXTENSIBLE *)data.blob.pBlobData;

        unsigned long depth = datum.Format.wBitsPerSample;
        if (datum.Format.wFormatTag == WAVE_FORMAT_EXTENSIBLE) if (datum.Format.wBitsPerSample) if (datum.Samples.wValidBitsPerSample) depth = datum.Samples.wValidBitsPerSample;
        string = audio_to_text(datum.Format.nChannels,depth,datum.Format.nSamplesPerSec);

        string_of_combo.AppendFormat("Format of speaker is %s (when in share).",string);
        string_of_combo.Append("\n");

        GUID minor = MFAudioFormat_Base; minor.Data1 = datum.Format.wFormatTag;
        if (datum.Format.wFormatTag == WAVE_FORMAT_EXTENSIBLE) minor = datum.SubFormat;
        string = type_to_text(MFMediaType_Audio,minor);

        string_of_combo.AppendFormat("Type of format is %s.",string);
        string_of_combo.Append("\n");

        PropVariantClear(&data);
       }
       store->Release(); store = NULL;
      }
      device->Release(); device = NULL;
     }
     enumerator->Release(); enumerator = NULL;
    }

    ////////////////////////////////////////

    zeroize(extent);
    extent.Format.wFormatTag = WAVE_FORMAT_EXTENSIBLE;
    extent.Format.nChannels = 2;
    extent.Format.nSamplesPerSec = 0; // for now
    extent.Format.wBitsPerSample = 16;
    extent.Format.nBlockAlign = extent.Format.nChannels * extent.Format.wBitsPerSample / 8;
    extent.Format.nAvgBytesPerSec = extent.Format.nSamplesPerSec * extent.Format.nBlockAlign;
    extent.Format.cbSize = sizeof(extent) - sizeof(extent.Format);
    extent.Samples.wValidBitsPerSample = extent.Format.wBitsPerSample;
    extent.dwChannelMask = KSAUDIO_SPEAKER_STEREO;
    extent.SubFormat = MFAudioFormat_PCM;

    ////////////////////////////////////////

    result = CoCreateInstance(_uuidof(MMDeviceEnumerator),NULL,CLSCTX_ALL,IID_PPV_ARGS(&enumerator));
    if (SUCCEEDED(result))
    {
     result = enumerator->GetDefaultAudioEndpoint(eRender,eMultimedia,&device);
     if (SUCCEEDED(result))
     {
      result = device->Activate(_uuidof(IAudioClient),CLSCTX_ALL,NULL,(void **)&client);
      if (SUCCEEDED(result))
      {
       for (index = 0; index < RTL_NUMBER_OF(items); index++)
       {
        // update the relevant things
        extent.Format.nSamplesPerSec = items[index];
        extent.Format.nAvgBytesPerSec = extent.Format.nSamplesPerSec * extent.Format.nBlockAlign;

        // search format
        result = client->IsFormatSupported(AUDCLNT_SHAREMODE_EXCLUSIVE,&extent.Format,NULL);
        if (FAILED(result)) continue;

        string_of_combo.AppendFormat("Rate of sample was found as %d.",extent.Format.nSamplesPerSec);
        string_of_combo.Append("\n");
       }
       client->Release(); client = NULL;
      }
      device->Release(); device = NULL;
     }
     enumerator->Release(); enumerator = NULL;
    }

    ////////////////////////////////////////

    if (string_of_combo.GetLength())
    {
     string.SetString(string_of_combo);
     string_of_combo.SetString("AUDIO OF HARDWARE");
     string_of_combo.Append("\n");
     string_of_combo.Append(string);
    }

    ////////////////////////////////////////

    string_of_combo.Trim();
    return string_of_combo;
}

// it is about hardware
CString capabilities_of_video()
{
CString string;
CString string_of_combo;
D3DDISPLAYMODE data;
D3DPRESENT_PARAMETERS present;
IDirect3D9 * direct;
IDirect3DDevice9 * device;
IDirectXVideoDecoderService * decode;
GUID * items;
UINT count;
UINT index;
HRESULT result;

    ////////////////////////////////////////

    direct = Direct3DCreate9(D3D_SDK_VERSION);
    if (direct)
    {
     result = direct->GetAdapterDisplayMode(D3DADAPTER_DEFAULT,&data);
     if (SUCCEEDED(result))
     {
      unsigned long depth = depth_of_video(data.Format);
      string = video_to_text(data.Width,data.Height,depth,data.RefreshRate);

      string_of_combo.AppendFormat("Format of screen is %s.",string);
      string_of_combo.Append("\n");

      GUID minor = MFVideoFormat_Base; minor.Data1 = data.Format;
      string = type_to_text(MFMediaType_Video,minor);

      string_of_combo.AppendFormat("Type of format is %s.",string);
      string_of_combo.Append("\n");
     }
     direct->Release(); direct = NULL;
    }

    ////////////////////////////////////////

    zeroize(present);
    present.SwapEffect = D3DSWAPEFFECT_COPY;
    present.Windowed = TRUE;

    ////////////////////////////////////////

    direct = Direct3DCreate9(D3D_SDK_VERSION);
    if (direct)
    {
     result = direct->CreateDevice(D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL,AfxGetMainWnd()->m_hWnd,D3DCREATE_HARDWARE_VERTEXPROCESSING,&present,&device);
     if (SUCCEEDED(result))
     {
      DXVA2CreateVideoService(device,IID_PPV_ARGS(&decode));
      if (SUCCEEDED(result))
      {
       result = decode->GetDecoderDeviceGuids(&count,&items);
       if (SUCCEEDED(result))
       {
        for (index = 0; index < count; index++)
        {
         // search name
         string.Empty();
         name_to_text(string,items[index],value_comma_name(DXVA2_ModeH264_IDCT_FGT));
         name_to_text(string,items[index],value_comma_name(DXVA2_ModeH264_IDCT_NoFGT));
         name_to_text(string,items[index],value_comma_name(DXVA2_ModeH264_MoComp_FGT));
         name_to_text(string,items[index],value_comma_name(DXVA2_ModeH264_MoComp_NoFGT));
         name_to_text(string,items[index],value_comma_name(DXVA2_ModeH264_VLD_FGT));
         name_to_text(string,items[index],value_comma_name(DXVA2_ModeH264_VLD_NoFGT));
         name_to_text(string,items[index],value_comma_name(DXVA2_ModeMPEG2_IDCT));
         name_to_text(string,items[index],value_comma_name(DXVA2_ModeMPEG2_MoComp));
         name_to_text(string,items[index],value_comma_name(DXVA2_ModeMPEG2_VLD));
         name_to_text(string,items[index],value_comma_name(DXVA2_ModeVC1_IDCT));
         name_to_text(string,items[index],value_comma_name(DXVA2_ModeVC1_MoComp));
         name_to_text(string,items[index],value_comma_name(DXVA2_ModeVC1_PostProc));
         name_to_text(string,items[index],value_comma_name(DXVA2_ModeVC1_VLD));
         name_to_text(string,items[index],value_comma_name(DXVA2_ModeWMV8_MoComp));
         name_to_text(string,items[index],value_comma_name(DXVA2_ModeWMV8_PostProc));
         name_to_text(string,items[index],value_comma_name(DXVA2_ModeWMV9_IDCT));
         name_to_text(string,items[index],value_comma_name(DXVA2_ModeWMV9_MoComp));
         name_to_text(string,items[index],value_comma_name(DXVA2_ModeWMV9_PostProc));
         if (string.IsEmpty()) string = CComBSTR(items[index]); // guid in place of name

         string_of_combo.AppendFormat("Type of decode is %s.",string);
         string_of_combo.Append("\n");
        }
        CoTaskMemFree(items); items = NULL;
       }
       decode->Release(); decode = NULL;
      }
      device->Release(); device = NULL;
     }
     direct->Release(); direct = NULL;
    }

    ////////////////////////////////////////

    if (string_of_combo.GetLength())
    {
     string.SetString(string_of_combo);
     string_of_combo.SetString("VIDEO OF HARDWARE");
     string_of_combo.Append("\n");
     string_of_combo.Append(string);
    }

    ////////////////////////////////////////

    string_of_combo.Trim();
    return string_of_combo;
}

// it gets type of media
HRESULT get_type(IMFTopologyNode * node, IMFMediaType ** type)
{
HRESULT result;
MF_TOPOLOGY_TYPE kind;
IUnknown * object;
IMFStreamDescriptor * descriptor;
IMFMediaTypeHandler * handler;
IMFStreamSink * sink;
IMFTransform * transform;

    // node may not has current type
    // even it is connected to other

    // for stream of node, type of media, and so forth
    // we do not examine the indexes that are non-zero

    if (node == NULL) return E_POINTER;
    if (type == NULL) return E_POINTER;

    result = node->GetNodeType(&kind);
    if (FAILED(result)) return result;

    ////////////////////////////////////////

    if (kind == MF_TOPOLOGY_SOURCESTREAM_NODE)
    {
     // it has only output, we can try flag
     result = MFGetTopoNodeCurrentType(node,0,TRUE,type);
     if (SUCCEEDED(result)) return result;

     // it has only output, we can try flag
     result = MFGetTopoNodeCurrentType(node,0,FALSE,type);
     if (SUCCEEDED(result)) return result;

     result = node->GetUnknown(MF_TOPONODE_STREAM_DESCRIPTOR,IID_PPV_ARGS(&descriptor));
     if (SUCCEEDED(result))
     {
      result = descriptor->GetMediaTypeHandler(&handler);
      if (SUCCEEDED(result))
      {
       result = handler->GetMediaTypeByIndex(0,type);
       if (SUCCEEDED(result))
       {
        // any thing is nope to do
       }
       handler->Release(); handler = NULL;
      }
      descriptor->Release(); descriptor = NULL;
     }

     if (SUCCEEDED(result)) return result;
    }

    ////////////////////////////////////////

    if (kind == MF_TOPOLOGY_OUTPUT_NODE)
    {
     // it has only input, we can try flag
     result = MFGetTopoNodeCurrentType(node,0,TRUE,type);
     if (SUCCEEDED(result)) return result;

     // it has only input, we can try flag
     result = MFGetTopoNodeCurrentType(node,0,FALSE,type);
     if (SUCCEEDED(result)) return result;

     result = node->GetObject(&object);
     if (SUCCEEDED(result))
     {
      result = object->QueryInterface(IID_PPV_ARGS(&sink));
      if (SUCCEEDED(result))
      {
       result = sink->GetMediaTypeHandler(&handler);
       if (SUCCEEDED(result))
       {
        result = handler->GetMediaTypeByIndex(0,type);
        if (SUCCEEDED(result))
        {
         // any thing is nope to do
        }
        handler->Release(); handler = NULL;
       }
       sink->Release(); sink = NULL;
      }
      object->Release(); object = NULL;
     }

     if (SUCCEEDED(result)) return result;
    }

    ////////////////////////////////////////

    if (kind == MF_TOPOLOGY_TRANSFORM_NODE)
    {
     // it has input and output, we can not try flag
     result = MFGetTopoNodeCurrentType(node,0,TRUE,type);
     if (SUCCEEDED(result)) return result;

     result = node->GetObject(&object);
     if (SUCCEEDED(result))
     {
      result = object->QueryInterface(IID_PPV_ARGS(&transform));
      if (SUCCEEDED(result))
      {
       result = transform->GetOutputAvailableType(0,0,type);
       if (SUCCEEDED(result))
       {
        // any thing is nope to do
       }
       transform->Release(); transform = NULL;
      }
      object->Release(); object = NULL;
     }

     if (SUCCEEDED(result)) return result;
    }

    ////////////////////////////////////////

    // as last remedy, let us cover all
    // for example MF_TOPOLOGY_TEE_NODE

    result = MFGetTopoNodeCurrentType(node,0,TRUE,type);
    if (SUCCEEDED(result)) return result;

    result = node->GetOutputPrefType(0,type);
    if (SUCCEEDED(result)) return result;

    result = MFGetTopoNodeCurrentType(node,0,FALSE,type);
    if (SUCCEEDED(result)) return result;

    result = node->GetInputPrefType(0,type);
    if (SUCCEEDED(result)) return result;

    ////////////////////////////////////////

    // we must not research a connected node
    // because type of media is not relevant

    return E_UNEXPECTED;
}

// it gets format of type
CString get_format(IMFMediaType * type)
{
GUID major;
GUID minor;
unsigned int data_1;
unsigned int data_2;
unsigned int data_3;
unsigned int data_4;
unsigned int data_5;
HRESULT result;

    if (type == NULL) return "";

    result = type->GetGUID(MF_MT_MAJOR_TYPE,&major);
    if (FAILED(result)) return "";

    if (major == MFMediaType_Audio)
    {
     data_1 = MFGetAttributeUINT32(type,MF_MT_AUDIO_NUM_CHANNELS,0);
     data_2 = MFGetAttributeUINT32(type,MF_MT_AUDIO_BITS_PER_SAMPLE,0);
     data_3 = MFGetAttributeUINT32(type,MF_MT_AUDIO_SAMPLES_PER_SECOND,0);

     return audio_to_text(data_1,data_2,data_3);
    }

    if (major == MFMediaType_Video)
    {
     result = MFGetAttributeSize(type,MF_MT_FRAME_SIZE,&data_1,&data_2);
     if (FAILED(result)) data_1 = data_2 = 0;

     result = type->GetGUID(MF_MT_SUBTYPE,&minor);
     if (FAILED(result)) data_3 = 0; else data_3 = depth_of_video(minor.Data1);

     result = MFGetAttributeRatio(type,MF_MT_FRAME_RATE,&data_4,&data_5);
     if (FAILED(result)) data_4 = data_5 = 0;

     // divide by zero is nope
     // round is nope for compatibility
     if (data_5) data_4 /= data_5; else data_4 = 0;

     return video_to_text(data_1,data_2,data_3,data_4);
    }

    // we are not interested in other types

    return "";
}

// it gets formats of nodes
CString get_formats(IMFTopology * topology)
{
CString string_of_kind;
CString string_of_format;
CString string_of_variety;
CString string_of_combo;
CTypedPtrArray <CPtrArray, IMFTopologyNode *> data;
IMFMediaType * type;
MF_TOPOLOGY_TYPE kind;
GUID major;
GUID minor;
HRESULT result;

    if (topology == NULL) return "";

    sort_nodes(topology,&data);

    for (int index = 0; index < data.GetCount(); index++)
    {
     string_of_kind.Empty();
     string_of_format.Empty();
     string_of_variety.Empty();

     result = data.GetAt(index)->GetNodeType(&kind);
     if (SUCCEEDED(result))
     {
      if (kind == MF_TOPOLOGY_OUTPUT_NODE) string_of_kind = "output";
      if (kind == MF_TOPOLOGY_SOURCESTREAM_NODE) string_of_kind = "source";
      if (kind == MF_TOPOLOGY_TEE_NODE) string_of_kind = "tee";
      if (kind == MF_TOPOLOGY_TRANSFORM_NODE) string_of_kind = "transform";
      kind = MF_TOPOLOGY_MAX;
     }

     result = get_type(data.GetAt(index),&type);
     if (SUCCEEDED(result))
     {
      string_of_format = get_format(type);
      type->Release(); type = NULL;
     }

     result = get_type(data.GetAt(index),&type);
     if (SUCCEEDED(result))
     {
      result = type->GetGUID(MF_MT_MAJOR_TYPE,&major);
      if (SUCCEEDED(result))
      {
       result = type->GetGUID(MF_MT_SUBTYPE,&minor);
       if (SUCCEEDED(result))
       {
        string_of_variety = type_to_text(major,minor);
        minor = GUID_NULL;
       }
       major = GUID_NULL;
      }
      type->Release(); type = NULL;
     }

     string_of_kind.Trim();
     string_of_format.Trim();
     string_of_variety.Trim();

     if (string_of_kind.IsEmpty()) string_of_kind = "unknown";
     if (string_of_format.IsEmpty()) string_of_format = "unknown";
     if (string_of_variety.IsEmpty()) string_of_variety = "unknown";

     string_of_combo.AppendFormat("Format of %s is %s.",string_of_kind,string_of_format);
     string_of_combo.Append("\n");

     string_of_combo.AppendFormat("Type of format is %s.",string_of_variety);
     string_of_combo.Append("\n");
    }

    while (data.GetCount())
    {
     data.GetAt(0)->Release(); data.RemoveAt(0);
    }

    string_of_combo.Trim();
    return string_of_combo;
}

// it gets name of item
CString get_file(IMFPMediaItem * item)
{
CString string;
PWSTR text;

    if (item)
    {
     if (SUCCEEDED(item->GetURL(&text)))
     {
      string = text; string.Trim();
      CoTaskMemFree(text); text = NULL;
     }
    }

    return string;
}

// it collects optional features from file
CString get_attributes(IMFPMediaItem * item)
{
CString string;
CString string_of_combo;
SHFILEINFO info;
PROPVARIANT data;
unsigned long count;
unsigned long index;
unsigned long index_of_audio;
unsigned long index_of_video;
int result;

    ////////////////////////////////////////

    if (item == NULL) return "";

    result = item->GetNumberOfStreams(&count);
    if (FAILED(result)) count = 0;

    // initialize highest number as signless
    index_of_audio = 0; index_of_audio -= 1;
    index_of_video = 0; index_of_video -= 1;

    // find indexes of streams
    for (index = 0; index < count; index++)
    {
     PropVariantInit(&data);
     result = item->GetStreamAttribute(index,MF_MT_MAJOR_TYPE,&data);
     if (SUCCEEDED(result))
     {
      if (*data.puuid == MFMediaType_Audio) if (index_of_audio > index) index_of_audio = index;
      if (*data.puuid == MFMediaType_Video) if (index_of_video > index) index_of_video = index;
      PropVariantClear(&data);
     }
    }

    ////////////////////////////////////////

    string = get_mime(get_file(item));
    if (string.GetLength())
    {
     string_of_combo.AppendFormat("Content of file is %s.",string);
     string_of_combo.Append("\n");
    }

    result = SHGetFileInfo(get_file(item),FILE_ATTRIBUTE_NORMAL,&info,sizeof(info),SHGFI_TYPENAME|SHGFI_USEFILEATTRIBUTES);
    if (result)
    {
     string_of_combo.AppendFormat("Type of file is %s.",info.szTypeName);
     string_of_combo.Append("\n");
    }

    PropVariantInit(&data);
    result = item->GetPresentationAttribute(MF_PD_DURATION,&data);
    if (SUCCEEDED(result))
    {
     string_of_combo.AppendFormat("Length of media is %s.",time_to_text(data.hVal.QuadPart,false));
     string_of_combo.Append("\n");
     PropVariantClear(&data);
    }

    if (count)
    {
     string_of_combo.AppendFormat("Number of streams is %lu.",count);
     string_of_combo.Append("\n");
    }

    ////////////////////////////////////////

    if (index_of_audio < count)
    {
     PropVariantInit(&data);
     result = item->GetStreamAttribute(index_of_audio,MF_MT_AUDIO_BITS_PER_SAMPLE,&data);
     if (SUCCEEDED(result))
     {
      if (data.lVal)
      {
       string_of_combo.AppendFormat("Depth of audio is %ld bits.",data.lVal);
       string_of_combo.Append("\n");
      }
      PropVariantClear(&data);
     }
    }

    if (index_of_audio < count)
    {
     PropVariantInit(&data);
     result = item->GetStreamAttribute(index_of_audio,MF_MT_AAC_AUDIO_PROFILE_LEVEL_INDICATION,&data);
     if (SUCCEEDED(result))
     {
      if (data.lVal)
      {
       string_of_combo.AppendFormat("Profile of audio is %ld.",data.lVal);
       string_of_combo.Append("\n");
      }
      PropVariantClear(&data);
     }
    }

    ////////////////////////////////////////

    if (index_of_video < count)
    {
     PropVariantInit(&data);
     result = item->GetStreamAttribute(index_of_video,MF_MT_MPEG2_PROFILE,&data);
     if (SUCCEEDED(result))
     {
      if (data.lVal)
      {
       string_of_combo.AppendFormat("Profile of video is %ld.",data.lVal);
       string_of_combo.Append("\n");
      }
      PropVariantClear(&data);
     }
    }

    if (index_of_video < count)
    {
     PropVariantInit(&data);
     result = item->GetStreamAttribute(index_of_video,MF_MT_FRAME_SIZE,&data);
     if (SUCCEEDED(result))
     {
      if (data.hVal.HighPart && data.hVal.LowPart)
      {
       string_of_combo.AppendFormat("Ratio of aspect is %s.",rate_to_text(data.hVal.HighPart,data.hVal.LowPart));
       string_of_combo.Append("\n");
      }
      PropVariantClear(&data);
     }
    }

    ////////////////////////////////////////

    string_of_combo.Trim();
    return string_of_combo;
}

// it collects topological nodes from file
CString get_components(IMFPMediaItem * item)
{
CString string;
CString string_of_combo;
IMFTopology * topology;
IMFTopologyNode * node;
IUnknown * object;
IMFStreamSink * sink;
IMFVideoDisplayControl * control;
IMFAudioPolicy * policy;
WORD count;
int result;

    ////////////////////////////////////////

    if (item == NULL) return "";

    if (hook_info().entries[0].classy != GUID_NULL)
    {
     // some of them may not be used later
     // we must write an appropriate thing

     string_of_combo.Append("Following has been scanned.");
     string_of_combo.Append("\n");
     string_of_combo.Append("\n");
    }

    ////////////////////////////////////////

    for (int index = 0; index < RTL_NUMBER_OF(hook_info().entries); index++)
    {
     if (hook_info().entries[index].classy == GUID_NULL) continue;

     string.Empty(); // initialize for search of name

     // search the transform
     if (string.IsEmpty())
     {
      if (hook_info().entries[index].demand == IID_IMFTransform)
      {
       PWSTR text;
       result = MFTGetInfo(hook_info().entries[index].classy,&text,NULL,NULL,NULL,NULL,NULL);
       if (SUCCEEDED(result))
       {
        string = text; string.Trim();
        CoTaskMemFree(text); text = NULL;
       }
      }
     }

     // search the class
     if (string.IsEmpty())
     {
      char text[1024]; DWORD size = sizeof(text);
      result = RegGetValue(HKEY_CLASSES_ROOT,CString("clsid") + "\\" + CComBSTR(hook_info().entries[index].classy).m_str,NULL,RRF_RT_REG_SZ,NULL,text,&size);
      if (result == ERROR_SUCCESS)
      {
       string = text; string.Trim();
      }
     }

     // last remedy
     if (string.IsEmpty())
     {
      string = CComBSTR(hook_info().entries[index].classy); // guid in place of name
     }

     // we did laziness about search of those
     // SchemeHandlers and ByteStreamHandlers

     // append information
     if (hook_info().entries[index].harder) string.Append(" (aware of DXVA)");
     if (hook_info().entries[index].selfer) string.Append(" (proxy of ware)");

     string_of_combo.Append(string);
     string_of_combo.Append("\n");
    }

    ////////////////////////////////////////

    topology = read_the_topology();
    if (topology)
    {
     result = topology->GetNodeCount(&count);
     if (SUCCEEDED(result))
     {
      for (WORD index = 0; index < count; index++)
      {
       result = topology->GetNode(index,&node);
       if (SUCCEEDED(result))
       {
        result = node->GetObject(&object);
        if (SUCCEEDED(result))
        {
         result = object->QueryInterface(IID_PPV_ARGS(&sink));
         if (SUCCEEDED(result))
         {
          result = MFGetService(sink,MR_AUDIO_POLICY_SERVICE,IID_PPV_ARGS(&policy));
          if (SUCCEEDED(result))
          {
           string_of_combo.Append("Audio Renderer");
           string_of_combo.Append("\n");
           policy->Release(); policy = NULL;
          }
          sink->Release(); sink = NULL;
         }
         object->Release(); object = NULL;
        }
        node->Release(); node = NULL;
       }
       // continue of loop
      }
      count = 0;
     }
     topology = NULL; // we must not release
    }

    ////////////////////////////////////////

    topology = read_the_topology();
    if (topology)
    {
     result = topology->GetNodeCount(&count);
     if (SUCCEEDED(result))
     {
      for (WORD index = 0; index < count; index++)
      {
       result = topology->GetNode(index,&node);
       if (SUCCEEDED(result))
       {
        result = node->GetObject(&object);
        if (SUCCEEDED(result))
        {
         result = object->QueryInterface(IID_PPV_ARGS(&sink));
         if (SUCCEEDED(result))
         {
          result = MFGetService(sink,MR_VIDEO_RENDER_SERVICE,IID_PPV_ARGS(&control));
          if (SUCCEEDED(result))
          {
           string_of_combo.Append("Video Renderer");
           string_of_combo.Append("\n");
           control->Release(); control = NULL;
          }
          sink->Release(); sink = NULL;
         }
         object->Release(); object = NULL;
        }
        node->Release(); node = NULL;
       }
       // continue of loop
      }
      count = 0;
     }
     topology = NULL; // we must not release
    }

    ////////////////////////////////////////

    topology = read_the_topology();
    if (topology)
    {
     string = get_formats(topology);
     if (string.GetLength())
     {
      string_of_combo.Append("\n");
      string_of_combo.Append(string);
      string_of_combo.Append("\n");
     }
     topology = NULL; // we must not release
    }

    ////////////////////////////////////////

    string_of_combo.Trim();
    return string_of_combo;
}

// it collects communal features from file
CString get_properties(IMFPMediaItem * item)
{
CString string;
CString string_of_media;
CString string_of_audio;
CString string_of_video;
CString string_of_combo;
char text[1024];
PROPVARIANT data;
unsigned long count;
unsigned long index;
unsigned long index_of_audio;
unsigned long index_of_video;
bool found;
int result;

    ////////////////////////////////////////

    if (item == NULL) return "";

    result = item->GetNumberOfStreams(&count);
    if (FAILED(result)) count = 0;

    // initialize highest number as signless
    index_of_audio = 0; index_of_audio -= 1;
    index_of_video = 0; index_of_video -= 1;

    // find indexes of streams
    for (index = 0; index < count; index++)
    {
     PropVariantInit(&data);
     result = item->GetStreamAttribute(index,MF_MT_MAJOR_TYPE,&data);
     if (SUCCEEDED(result))
     {
      if (*data.puuid == MFMediaType_Audio) if (index_of_audio > index) index_of_audio = index;
      if (*data.puuid == MFMediaType_Video) if (index_of_video > index) index_of_video = index;
      PropVariantClear(&data);
     }
    }

    ////////////////////////////////////////

    string = get_part(get_file(item),body_of_path);
    if (string.GetLength())
    {
     string_of_media.AppendFormat("Name is %s.",string);
     string_of_media.Append("\n");
    }

    PropVariantInit(&data);
    result = item->GetPresentationAttribute(MF_PD_DURATION,&data);
    if (SUCCEEDED(result))
    {
     string_of_media.AppendFormat("Length is %s.",time_to_text(data.hVal.QuadPart,true));
     string_of_media.Append("\n");
     PropVariantClear(&data);
    }

    PropVariantInit(&data);
    result = item->GetPresentationAttribute(MF_PD_TOTAL_FILE_SIZE,&data);
    if (SUCCEEDED(result))
    {
     StrFormatByteSize64(data.hVal.QuadPart,text,sizeof(text));
     string_of_media.AppendFormat("Size is %s.",text);
     string_of_media.Append("\n");
     PropVariantClear(&data);
    }

    string = get_part(get_file(item),tail_of_path);
    if (string.GetLength())
    {
     string_of_media.AppendFormat("Type is %s.",string);
     string_of_media.Append("\n");
    }

    ////////////////////////////////////////

    if (index_of_audio < count)
    {
     PropVariantInit(&data);
     result = item->GetStreamAttribute(index_of_audio,MF_MT_AUDIO_NUM_CHANNELS,&data);
     if (SUCCEEDED(result))
     {
      if (data.lVal)
      {
       string_of_audio.AppendFormat("Channels are %ld pieces.",data.lVal);
       string_of_audio.Append("\n");
      }
      PropVariantClear(&data);
     }
    }

    if (index_of_audio < count)
    {
     PropVariantInit(&data);
     result = item->GetStreamAttribute(index_of_audio,MF_MT_AUDIO_SAMPLES_PER_SECOND,&data);
     if (SUCCEEDED(result))
     {
      if (data.lVal)
      {
       string_of_audio.AppendFormat("Samples per second are %ld.",data.lVal);
       string_of_audio.Append("\n");
      }
      PropVariantClear(&data);
     }
    }

    found = false;

    if (index_of_audio < count)
    {
     PropVariantInit(&data);
     result = item->GetStreamAttribute(index_of_audio,MF_MT_AUDIO_AVG_BYTES_PER_SECOND,&data);
     if (SUCCEEDED(result))
     {
      if (data.lVal)
      {
       StrFormatByteSize(data.lVal,text,sizeof(text));
       string_of_audio.AppendFormat("Data per second is %s.",text);
       string_of_audio.Append("\n");
       found = true;
      }
      PropVariantClear(&data);
     }
    }

    if (found == false)
    {
     PropVariantInit(&data);
     result = item->GetPresentationAttribute(MF_PD_AUDIO_ENCODING_BITRATE,&data);
     if (SUCCEEDED(result))
     {
      if (data.lVal)
      {
       StrFormatByteSize(data.lVal/8,text,sizeof(text));
       string_of_audio.AppendFormat("Data per second is %s.",text);
       string_of_audio.Append("\n");
      }
      PropVariantClear(&data);
     }
    }

    if (index_of_audio < count)
    {
     PropVariantInit(&data);
     result = item->GetStreamAttribute(index_of_audio,MF_MT_SUBTYPE,&data);
     if (SUCCEEDED(result))
     {
      if (data.puuid)
      {
       string_of_audio.AppendFormat("Type is %s.",type_to_text(MFMediaType_Audio,*data.puuid));
       string_of_audio.Append("\n");
      }
      PropVariantClear(&data);
     }
    }

    ////////////////////////////////////////

    if (index_of_video < count)
    {
     PropVariantInit(&data);
     result = item->GetStreamAttribute(index_of_video,MF_MT_FRAME_SIZE,&data);
     if (SUCCEEDED(result))
     {
      if (data.hVal.HighPart && data.hVal.LowPart)
      {
       string_of_video.AppendFormat("Dimensions are %ld by %ld.",data.hVal.HighPart,data.hVal.LowPart);
       string_of_video.Append("\n");
      }
      PropVariantClear(&data);
     }
    }

    if (index_of_video < count)
    {
     PropVariantInit(&data);
     result = item->GetStreamAttribute(index_of_video,MF_MT_FRAME_RATE,&data);
     if (SUCCEEDED(result))
     {
      if (data.hVal.HighPart && data.hVal.LowPart)
      {
       // round is nope for compatibility
       string_of_video.AppendFormat("Samples per second are %ld.",data.hVal.HighPart/data.hVal.LowPart);
       string_of_video.Append("\n");
      }
      PropVariantClear(&data);
     }
    }

    found = false;

    if (index_of_video < count)
    {
     PropVariantInit(&data);
     result = item->GetStreamAttribute(index_of_video,MF_MT_AVG_BITRATE,&data);
     if (SUCCEEDED(result))
     {
      if (data.lVal)
      {
       StrFormatByteSize(data.lVal/8,text,sizeof(text));
       string_of_video.AppendFormat("Data per second is %s.",text);
       string_of_video.Append("\n");
       found = true;
      }
      PropVariantClear(&data);
     }
    }

    if (found == false)
    {
     PropVariantInit(&data);
     result = item->GetPresentationAttribute(MF_PD_VIDEO_ENCODING_BITRATE,&data);
     if (SUCCEEDED(result))
     {
      if (data.lVal)
      {
       StrFormatByteSize(data.lVal/8,text,sizeof(text));
       string_of_video.AppendFormat("Data per second is %s.",text);
       string_of_video.Append("\n");
      }
      PropVariantClear(&data);
     }
    }

    if (index_of_video < count)
    {
     PropVariantInit(&data);
     result = item->GetStreamAttribute(index_of_video,MF_MT_SUBTYPE,&data);
     if (SUCCEEDED(result))
     {
      if (data.puuid)
      {
       string_of_video.AppendFormat("Type is %s.",type_to_text(MFMediaType_Video,*data.puuid));
       string_of_video.Append("\n");
      }
      PropVariantClear(&data);
     }
    }

    ////////////////////////////////////////

    if (string_of_media.GetLength())
    {
     string_of_combo.Append("\n");
     string_of_combo.Append("MEDIA");
     string_of_combo.Append("\n");
     string_of_combo.Append(string_of_media);
    }

    if (string_of_audio.GetLength())
    {
     string_of_combo.Append("\n");
     string_of_combo.Append("AUDIO");
     string_of_combo.Append("\n");
     string_of_combo.Append(string_of_audio);
    }

    if (string_of_video.GetLength())
    {
     string_of_combo.Append("\n");
     string_of_combo.Append("VIDEO");
     string_of_combo.Append("\n");
     string_of_combo.Append(string_of_video);
    }

    string_of_combo.Trim();
    return string_of_combo;
}

// it fixes when dimensions happened out of range
// and it moves coordinates from outside to inside
void normalize_rectangle(MFVideoNormalizedRect & rectangle)
{
float width,height;

    width = rectangle.right - rectangle.left;
    height = rectangle.bottom - rectangle.top;

    ////////////////////////////////////////

    if (width < 0)
    {
     rectangle.left = 0;
     rectangle.right = 0;
     width = rectangle.right - rectangle.left;
    }

    if (height < 0)
    {
     rectangle.top = 0;
     rectangle.bottom = 0;
     height = rectangle.bottom - rectangle.top;
    }

    if (width > 1)
    {
     rectangle.left = 0;
     rectangle.right = 1;
     width = rectangle.right - rectangle.left;
    }

    if (height > 1)
    {
     rectangle.top = 0;
     rectangle.bottom = 1;
     height = rectangle.bottom - rectangle.top;
    }

    ////////////////////////////////////////

    if (rectangle.left < 0)
    {
     rectangle.left = 0;
     rectangle.right = rectangle.left + width;
    }

    if (rectangle.top < 0)
    {
     rectangle.top = 0;
     rectangle.bottom = rectangle.top + height;
    }

    if (rectangle.right > 1)
    {
     rectangle.right = 1;
     rectangle.left = rectangle.right - width;
    }

    if (rectangle.bottom > 1)
    {
     rectangle.bottom = 1;
     rectangle.top = rectangle.bottom - height;
    }
}

// it closes stream to not flow
void close_stream(IMFPMediaItem * item, const GUID type)
{
PROPVARIANT data;
unsigned long count;
unsigned long index;
HRESULT result;

    if (item)
    {
     result = item->GetNumberOfStreams(&count);
     if (SUCCEEDED(result))
     {
      for (index = 0; index < count; index++)
      {
       PropVariantInit(&data);
       result = item->GetStreamAttribute(index,MF_MT_MAJOR_TYPE,&data);
       if (SUCCEEDED(result))
       {
        if (*data.puuid == type)
        {
         item->SetStreamSelection(index,FALSE);
        }
        PropVariantClear(&data);
       }
      }
     }
    }
}

// it copies and sorts nodes, caller must release them
void sort_nodes(IMFTopology * topology, CTypedPtrArray <CPtrArray, IMFTopologyNode *> * data)
{
HRESULT result;
WORD count;
DWORD temp;
MF_TOPOLOGY_TYPE type;
IMFTopologyNode * node;

    // we will look at first streams of nodes
    // because first streams are main streams

    // streams of source are separate nodes in topology
    // (audio and video of source are not in same node)

    if (topology == NULL) return;
    if (data == NULL) return;
    if (data->GetCount()) return;

    result = topology->GetNodeCount(&count);
    if (FAILED(result)) return;

    // nodes to array
    for (WORD index = 0; index < count; index++)
    {
     result = topology->GetNode(index,&node);
     if (SUCCEEDED(result))
     {
      data->Add(node);
      node = NULL; // we must not release
     }
     // continue of loop
    }

    // mains of nodes to head of array
    // keeping the orders between them
    for (int index1 = 0, index2 = 0; index1 < data->GetCount(); index1++)
    {
     result = data->GetAt(index1)->GetNodeType(&type);
     if (SUCCEEDED(result))
     {
      if (type == MF_TOPOLOGY_SOURCESTREAM_NODE)
      {
       if (index1 != index2)
       {
        // swap of elements
        auto temp1 = data->GetAt(index1);
        auto temp2 = data->GetAt(index2);
        data->SetAt(index1,temp2);
        data->SetAt(index2,temp1);
        temp1 = NULL; // end of scope does nope
        temp2 = NULL; // but extra safe is good
       }
       index2++;
      }
      type = MF_TOPOLOGY_MAX;
     }
     // continue of loop
    }

    // mains of nodes in head of array
    // sides of nodes to body of array
    for (int index1 = 0; index1 < data->GetCount() - 2; index1++)
    {
     result = data->GetAt(index1)->GetOutput(0,&node,&temp);
     if (SUCCEEDED(result))
     {
      for (int index2 = index1 + 2; index2 < data->GetCount(); index2++)
      {
       if (data->GetAt(index2) == node)
       {
        // move does fine
        // swap does fail
        data->RemoveAt(index2);
        data->InsertAt(index1 + 1,node);
        break; // more is nope
       }
       // continue of loop
      }
      node->Release(); node = NULL;
     }
     // continue of loop
    }

    // lones of nodes to tail of array
    // (this may happen automatically)

    // according to connections, we sorted the nodes
    // but still, orders of audio and video remained
    // it is because of indexes of nodes of topology
    // also, because of indexes of streams of source
}
