// implementation of declaration

#include <sdkddkver.h>
#include <afxwin.h>
#include <mfplay.h>
#include "resource.h"
#include "common.h"
#include "qualifier.h"
#include "tracer.h"

BEGIN_MESSAGE_MAP(tracer, CDialog)
    ON_WM_TIMER()
END_MESSAGE_MAP()

tracer::tracer() : CDialog(tracer::IDD)
{
    m_timer = 0;
}

tracer::~tracer()
{
}

void tracer::DoDataExchange(CDataExchange * data)
{
    CDialog::DoDataExchange(data);

    DDX_Control(data, IDC_TRACER_ROW_1, m_row_1);
    DDX_Control(data, IDC_TRACER_ROW_2, m_row_2);
    DDX_Control(data, IDC_TRACER_ROW_3, m_row_3);
    DDX_Control(data, IDC_TRACER_ROW_4, m_row_4);
    DDX_Control(data, IDC_TRACER_ROW_5, m_row_5);
    DDX_Control(data, IDC_TRACER_ROW_6, m_row_6);
}

BOOL tracer::OnInitDialog()
{
    CDialog::OnInitDialog();

    // turn from font-of-edit into font-of-run
    m_font.CreatePointFont(0,"obelus"); SetFont(&m_font);
    SendMessageToDescendants(WM_SETFONT,(WPARAM)m_font.m_hObject);

    get_stat_1(); m_row_1.SetWindowText("");
    get_stat_2(); m_row_2.SetWindowText("");
    get_stat_3(); m_row_3.SetWindowText("");
    get_stat_4(); m_row_4.SetWindowText("");
    get_stat_5(); m_row_5.SetWindowText("");
    get_stat_6(); m_row_6.SetWindowText("");

    m_timer = SetTimer(1,1000,NULL);

    return TRUE;
}

void tracer::OnTimer(UINT_PTR identifier)
{
    if (identifier)
    {
     if (identifier == m_timer)
     {
      set_text(m_row_1,get_stat_1());
      set_text(m_row_2,get_stat_2());
      set_text(m_row_3,get_stat_3());
      set_text(m_row_4,get_stat_4());
      set_text(m_row_5,get_stat_5());
      set_text(m_row_6,get_stat_6());
     }
    }

    CDialog::OnTimer(identifier);
}

CString tracer::get_stat_1()
{
CFileTime time_of_exit;
CFileTime time_of_user;
CFileTime time_of_create;
CFileTime time_of_kernel;
unsigned long long count;
CString string;

    // check of error is nope for simplicity
    // user does understand from malfunction
    GetProcessTimes(GetCurrentProcess(),&time_of_create,&time_of_exit,&time_of_kernel,&time_of_user);

    count = 0; // let us add them
    count += time_of_user.GetTime();
    count += time_of_kernel.GetTime();

    count -= m_save; // subtract each other
    m_save += count; // then add each other

    count += (CFileTime::Millisecond * 5); // round up
    count /= (CFileTime::Millisecond * 10); // in centiseconds
    if (count > 100) count = 100; // because of delay of function and so forth

    // ummm ...
    // amount of process
    // use of processor
    // degree of process
    // quantity of process
    // hmmm ...
    string.Format("Amount of process per cent is %llu.",count);
    string.Insert(0,32); // for show good

    return string;
}

CString tracer::get_stat_2()
{
long count;
CString string;

    count = read_then_zeroize_the_cleans_of_audio();

    string.Format("Cleans of audio per second are %ld.",count);
    string.Insert(0,32); // for show good

    return string;
}

CString tracer::get_stat_3()
{
long count;
CString string;

    count = read_then_zeroize_the_cleans_of_video();

    string.Format("Cleans of video per second are %ld.",count);
    string.Insert(0,32); // for show good

    return string;
}

CString tracer::get_stat_4()
{
long count;
CString string;

    count = read_then_zeroize_the_passes_of_audio();

    string.Format("Passes of audio per second are %ld.",count);
    string.Insert(0,32); // for show good

    return string;
}

CString tracer::get_stat_5()
{
long count;
CString string;

    count = read_then_zeroize_the_passes_of_video();

    string.Format("Passes of video per second are %ld.",count);
    string.Insert(0,32); // for show good

    return string;
}

CString tracer::get_stat_6()
{
IO_COUNTERS counters;
unsigned long long count;
CString string;

    // check of error is nope for simplicity
    // user does understand from malfunction
    GetProcessIoCounters(GetCurrentProcess(),&counters);

    count = 0; // let us add them
    count += counters.ReadOperationCount;
    count += counters.WriteOperationCount;
    count += counters.OtherOperationCount;

    string.Format("Performs of input and output are %llu.",count);
    string.Insert(0,32); // for show good

    return string;
}
